/**@file
 *			Patches for Anthy, by G-HAL
 *@brief	Anthy Ⱦǡ
 *@date		Thu,21 Aug,2008 - Fri,29 Aug,2008
 *@date		Fri,17 Oct,2008 - Sat,18 Oct,2008
 *@date		Tue,21 Oct,2008 - Thu,23 Oct,2008
 *@date		Tue,28 Oct,2008
 *@date		Fri,31 Oct,2008
 *@date		Sat,01 Nov,2008 - Tue,04 Nov,2008
 *@date		Fri,14 Nov,2008 - Wed,19 Nov,2008
 *@date		Sat,22 Nov,2008, Thu,27 Nov,2008
 *@date		Sat,29 Nov,2008
 *@date		Tue,30 Dec,2008
 *@date		Tue,13 Jan,2009
 *@date		Mon,19 Jan,2009
 *@date		Sat,24 Jan,2009, Sun,25 Jan,2009
 *@date		Mon,26 Jan,2009, Thu,29 Jan,2009
 *@date		Tue,03 Feb,2009, Wed,04 Feb,2009, Fri,06 Feb,2009
 *@date		Sun,08 Feb,2009
 *@author	Copyright(C)2008-2009 G-HAL
 */
#ifndef _settings_h_included_
#define _settings_h_included_

#if !defined(__STDC_LIMIT_MACROS)
# define	__STDC_LIMIT_MACROS
#endif
#include <stdint.h>

#include <limits.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>

#ifdef __cplusplus
extern "C" {
#endif


#if !defined(SIZEOF_TIME_T) || (SIZEOF_TIME_T < 8)
	typedef		int64_t		anthy_time_t;
#else
	typedef		time_t		anthy_time_t;
#endif

#if !defined(_number_)
# define		_number_(arr)			(sizeof(arr)/sizeof((arr)[0]))
#endif



/** Anthy γؽΥ
 *@note
 *		ե뵭Ͽ anthy_settings_record[] Υ̾
 *		ϿΤǡ֤ϤɤǤ褤
 *		դ˸ȡanthy_settings_record[] 
 *		enum ν˰¸ϹԤʤȡ
 */
enum ANTHY_SECTIONS_ {
	NONE_SECTION,	/**< ʼ */
	EXPANDPAIR,
	UNKNOWN_WORD,
	SUFFIX_HISTORY,
	INDEPPAIR,
	OCHAIRE,
	CAND_HISTORY,
	PREDICTION,
	INDEP_HISTORY,
	DEP_HISTORY,
	PREFIX_HISTORY,
	MAX_SECTION		/**< ʼ */
};

#ifdef __cplusplus
inline ANTHY_SECTIONS_& operator ++ ( ANTHY_SECTIONS_& arg )
{
	arg = static_cast<ANTHY_SECTIONS_>(arg + 1);
	return arg;
}

inline ANTHY_SECTIONS_& operator -- ( ANTHY_SECTIONS_& arg )
{
	arg = static_cast<ANTHY_SECTIONS_>(arg - 1);
	return arg;
}
#endif



/** ʸڤΥ⡼
 */
enum ANTHY_LATTICE_MODE_T {
	ANTHY_LATTICE_MODE_VITERBI,				/**< ꥸʥ Anthy ɤʥӥӥ르ꥺˤ뱣ޥ륳եǥѷˡ̵ */
	ANTHY_LATTICE_MODE_MAXLEN_BY_N_PHRASES,	/**< ʸĹסʸ */
};



/** Anthy Ⱦǡ */
struct ANTHY_SETTINGS_ {

								/** ॹ׾ */
	struct {
		time_t	conffile;			/**< Ķեκɤ߹߸ */
		time_t	initial;			/**< ưΥॹסʽѡ */
		time_t	currentsession;		/**< ߽ѴåΥॹ */
	} timestamp;

								/** ե롿ǥ쥯ȥ̾ */
	struct {
		char	user_conffile[PATH_MAX];		/**< 桼Ķե */
		char	PathSeparator[PATH_MAX];		/**< ǥ쥯ȥζڤʸ */
		char	user_dir[PATH_MAX];				/**< ե뷲֤ǥ쥯ȥ */
		char	lock_file[PATH_MAX];			/**< åե̾ */
		char	private_dic[PATH_MAX];			/**< Ŀɲü̾ */
		char	private_dic_ext[PATH_MAX];		/**< Ŀɲüγĥ */
		char	imported_words[PATH_MAX];		/**< imported_words ǥ쥯ȥ̾ */
		char	imported_words_ext[PATH_MAX];	/**< imported_words ǥ쥯ȥ̾γĥ */
		char	record1[PATH_MAX];				/**< last-record1_* δ̾ */
		char	record1_bin_ext[PATH_MAX];		/**< last-record1_* ΥХʥγĥ */
		char	record2[PATH_MAX];				/**< last-record2_* δ̾ */
		char	record_ext[PATH_MAX];			/**< last-record?_*  UTF äγĥ */
	} filename;

	mode_t	file_umask;				/**< ե°ޥѡߥåΡ黻ʤΤա */

	size_t	recordfile2_limit;		/**< last-record2_* 礭ۤ顢եå夷 last-record1_default إޡ */
	size_t	recordfile1_limit;		/**< last-record1_* 礭ۤ顢ȥߤ */

								/** ƳؽΥҥȾ */
	struct {
		const char* const	name;			/**< ̾ */
		size_t				max_entry;		/**< 票ȥʳؽѡ */
		size_t				default_nr_num;	/**< ȥǤɸ५ʹ®ΰ٤ΥԳѡ */
		size_t				inc_nr_num;		/**< ȥǤɸ५ÿʹ®ΰ٤Υѡ */
	} section[MAX_SECTION];

								/** ͤ */
	struct {
		size_t		ochaire_mindepth;			/**< OCHAIREؽκǾʸ */
		size_t		ochaire_maxdepth;			/**< OCHAIREؽκʸ */
		size_t		historyrecord_maxdepth;		/**< ؽκϿ */
	} limit;

								/** ɲõǽ̵ͭ */
	struct {
									/** ؽǽ̵ͭ */
		struct {
			int		enable_unlearn;						/**< CAND_HISTORYOCHAIREˤơؽ褦ȤƤȿ¸γؽĴ¸γؽ⤫ä硢¸γؽΥŪ˲ */
			int		enable_release;						/**< OCHAIREˤơؽ褦ȤʸƤ򤵤˺ʬͤʴ¸γؽä硢 */
			int		enable_prediction;					/**< PREDICTIONؽͭ(1)̵(0)  */
			int		enable_candhistory;					/**< CAND_HISTORYؽͭ(1)̵(0)  */
			int		enable_indeppair;					/**< INDEPPAIRؽͭ(1)̵(0)  */
			int		enable_indephistory;				/**< INDEP_HISTORYؽͭ(1)̵(0)  */
			int		enable_dephistory;					/**< DEP_HISTORYؽͭ(1)̵(0)  */
			int		enable_ochaire2;					/**< Ω졦°դʸOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire2_wo_dep;				/**< °̵ʸOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire2_wo_indep;			/**< Ω̵ʸOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire2_wo_indep_wo_dep;	/**< Ω졦°̵ʸOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire3;					/**< Ω졦°դʸʾOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire3_wo_dep;				/**< °̵ʸʾOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire3_wo_indep;			/**< Ω̵ʸʾOCHAIREؽͭ(1)̵(0)  */
			int		enable_ochaire3_wo_indep_wo_dep;	/**< Ω졦°̵ʸʾOCHAIREؽͭ(1)̵(0)  */
		} learn;
									/** ʸڤ */
		struct {
			enum ANTHY_LATTICE_MODE_T	mode;	/**< ʸڤΥ⡼ */
			int		with_candhistory;			/**< ʸڤ CAND_HISTORY ͥ褹(1)(0) */
			int		with_cand_score;			/**< ʸڤκݤʸδܥȤơñΥѤ(1)ñνм̥OCHAIREݤդˤѤ(0) */
			int		with_candstruct_score;		/**< ʸڤκݤˡ°ˤʸδܥԤ(1)(0) */
			int		with_cand_corpus;			/**< ʸڤκݤˡcand_info ѥˤʸδܥԤ(1)(0)false == with_candstruct_score ξ϶Ū̵ */
			int		with_dep_history;			/**< ʸڤκݤˡ°ؽˤʸδܥԤ(1)(0) */
												/** ʸĹץ⡼ͭ */
			struct {
				int		phrases;					/**< ʸ */
				int		phrase_with_pre_post_as_2;	/**< ʸĹץ⡼ɻˡƬξʸ򡢣ʸȿ(1)ݤ(0) */
				int		autoexpand_deps;			/**< °μưĥԤ(1)(0) */
			} maxlen_mode;
		} lattice;

									/** ° */
		struct {
			int		with_xct_symbol;		/**< XCT_SYMBOLʸ°ȤϢ뤹(1)(0) */
			int		with_xct_part;			/**< XCT_PARTʸʤáˤ°ȤϢ뤹(1)(0) */
											/** °ʸ᥹ؤαƶ */
			struct {
				double	decrease_ratio;					/**< ʸṽ¤򲼤Ψ°죱 */
				double	decrease_ratio_by_length;		/**< ʸṽ¤򲼤Ψ°죱ʸ */
				double	decrease_biasratio;				/**< ʸṽ¤򲼤Ψʲط̵Ψ */
				int		decrease_biasratio_threshold;	/**< decrease_biasratio ͭˤ롢°κ */
				int		decrease_score;					/**< ʸṽ¤˲û°죱 */
				int		decrease_biasscore;				/**< ʸṽ¤˲ûʲط̵ */
				int		decrease_biasscore_threshold;	/**< decrease_biasscore ͭˤ롢°κ */
				int		increase_biasscore_by_learn;	/**< DEP_HISTORYؽ˥ҥåȤβʤ * log(1.0 + ޤǤѲ) */
			} score;
		} depgraph;

									/** Ƭ */
		struct {
											/** ʸ᥹ؤαƶ */
			struct {
				double	increase_ratio_by_learn;		/**< ʸ᥹夲 */
			} score;
		} prefix_suffix;

									/** ʸФüɲ */
		struct {
										/** ޤʸؽʤ(1)ؽ(0)cf:src-worddic/exception_word_list.c */
			struct {
				int		indep_history;			/**< INDEPPAIR/INDEP_HISTORY/DEP_HISTORY ˳ؽʤ */
				int		ochaire;				/**< OCHAIRE ˳ؽʤ */
				int		cand_history;			/**< CAND_HISTORY ˳ؽʤ */
				int		prediction;				/**< PREDICTION ˳ؽʤ */
			} exception_word;
			unsigned int	guess;				/**< üե饰ɲáư줿Ǹʸʳʤʸ */
			unsigned int	hiragana;			/**< üե饰ɲáư줿Ҥ餬ʤΤߤʸ */
			unsigned int	katakana;			/**< üե饰ɲáư줿ʤΤߤʸ */
			unsigned int	kigou;				/**< üե饰ɲáư줿εΤߤʸsrc-diclib/xchar.c  half_wide_tab 򻲾ȡ */
			unsigned int	muhenkan;			/**< üե饰ɲáư줿̵Ѵʸ */
			unsigned int	zenhan;				/**< üե饰ɲáư줿ѤȤȾѤؤʪ */
			unsigned int	num_ank;			/**< üե饰ɲáư줿ȾѤο(ANK) */
			unsigned int	num_jis;			/**< üե饰ɲáư줿Ѥο(JIS X 0208 ) */
			unsigned int	num_kansuuzi;		/**< üե饰ɲáư줿 */
			unsigned int	num_separated_ank;	/**< üե饰ɲáư줿ڤ(ANK) */
			unsigned int	num_separated_jis;	/**< üե饰ɲáư줿ڤ(JIS X 0208 ) */
			unsigned int	num_zipcode;		/**< üե饰ɲá͹ֹ漭񤫤Ѵ */
		} extra_flag;
	} anthy_mode;
};

/** Anthy Ⱦǡ */
extern struct ANTHY_SETTINGS_ anthy_settings;



/** ѥ᡼μ */
extern void anthy_init_settings( void );

/** ƥĶμ */
extern void anthy_load_settings_from_systemconf( void );

/** 桼Ķμ */
extern void anthy_load_settings( void );


#ifdef __cplusplus
}
#endif

#endif /* _settings_h_included_ */
/* [ End of File ] */
