/* splitter⥸塼Υ󥿡ե */
#ifndef _splitter_h_included_
#define _splitter_h_included_

#include <anthy/dic.h>
#include <anthy/xstr.h>
#include <anthy/wtype.h>
#include <anthy/segclass.h>

#ifdef __cplusplus
extern "C" {
#endif

/* ѥ᡼ */
#define RATIO_BASE 256
#define OCHAIRE_SCORE			4000000					/**< OCHAIREؽͳθΥ Patched by G-HAL, Tue,13 Jan,2009 */
#define OCHAIRE_ADDSCORE		(OCHAIRE_SCORE * 2 / 8)	/**< OCHAIREؽͳθɲåʸˤû, Patched by G-HAL, Sat,15 Nov,2008 */
#define CANDHISTORY_SCORE		(OCHAIRE_SCORE * 6 / 8)	/**< CAND_HISTORYؽͳθΥȥåס, Patched by G-HAL, Thu,13 Nov,2008, Fri,14 Nov,2008 */
#define CANDHISTORY_ADDSCORE	(OCHAIRE_SCORE * 4 / 8)	/**< CAND_HISTORYؽͳθΥȥåװʳκ͡, Patched by G-HAL, Sat,15 Nov,2008 */
#define INDEPHISTORY_ADDSCORE	(OCHAIRE_SCORE * 2 / 8)	/**< INDEP_HISTORYؽͳθΥ٤ˤ͡, Patched by G-HAL, Tue,13 Jan,2009 */

/** splitterΥƥȡ
 * ǽζ꤫anthy_contextβޤͭ
 */
struct splitter_context {
  /** splitterǻѤ빽¤ */
  struct word_split_info_cache *word_split_info;
  int char_count;
  int is_reverse;
  struct char_ent {
    xchar *c;
    int seg_border;
    int initial_seg_len;/* ǽʸʬκݤˤϤޤäʸ᤬
			   ФĹ */
    enum seg_class best_seg_class;
    struct meta_word* best_mw; /* ͥ褷ƻȤmetaword */
  }*ce;
};

/* Υåξ */
enum constraint_stat {
  unchecked, ok, ng
};

/* ȤꤢŬ䤷Ƥߤ꤬Фʬह */
enum metaword_type {
  /* ߡ : seginfoʤ */
  MW_DUMMY,
  /* wordlist0 or Ĵޤ */
  MW_SINGLE,
  /* ̤metawordĤޤ: metaword +  ʤ :seginfomw1 */
  MW_WRAP,
  /* ʣƬ */
  MW_COMPOUND_HEAD,
  /* ʣ */
  MW_COMPOUND,
  /* ʣΰʸ */
  MW_COMPOUND_LEAF,
  /* ʣθġʸ礷ưĤʸȤƤߤ */
  MW_COMPOUND_PART,
  /* ưϢѷ + ƻ */
  MW_V_RENYOU_A,
  /* ưϢѷ + ̾ */
  MW_V_RENYOU_NOUN,
  /*  */
  MW_NUMBER,
  /**/
  MW_OCHAIRE,
  MW_OCHAIREwithoutDEP,				/**< Patched by G-HAL, Sat,24 Jan,2009 */
  MW_OCHAIREwithoutINDEP,			/**< Patched by G-HAL, Sun,08 Feb,2009 */
  MW_OCHAIREwithoutINDEPwithoutDEP,	/**< Patched by G-HAL, Sun,08 Feb,2009 */
  MW_CANDHISTORY,					/**< Patched by G-HAL, Tue,04 Nov,2008 */
  /**/
  MW_END
};

#define MW_FEATURE_NONE 0
#define MW_FEATURE_SV 1
#define MW_FEATURE_WEAK_CONN 2
#define MW_FEATURE_SUFFIX 4
#define MW_FEATURE_NUM 16
#define MW_FEATURE_CORE1 32
#define MW_FEATURE_DEP_ONLY 64
#define MW_FEATURE_HIGH_FREQ 128
#define MW_FEATURE_WEAK_SEQ 256

/*
 * meta_word: θоݤȤʤ
 * ñword_listޤΤ¾ˤĤμब롥
 *
 */
struct meta_word {
  int from, len;
  /* ʸᶭθФ˻Ѥ륹 */
  int score;
  /* λ˻Ѥ륹 */
  int struct_score;
  int	extra_score;			/**< ؽͳɲå, Patched by G-HAL, Wed,04 Feb,2009 */
  /* ξ */
  int dep_word_hash;
  int mw_features;
  wtype_t core_wt;
  enum dep_class dep_class;
  /**/
  enum seg_class seg_class;
  enum constraint_stat can_use; /* ȶ˸٤äƤʤ */
  enum metaword_type type;
  int ochaire_opposite;			/**< CAND_HISTORYؽͳmetawordOCHAIREй⡼ɤǻѤե饰, Patched by G-HAL, Mon,17 Nov,2008 */
  struct word_list *wl;
  int ochaire_phrases;			/**< OCHAIREؽͳmetawordʸ, Patched by G-HAL, Fri,14 Nov,2008 */
  int ochaire_total_len;		/**< OCHAIREؽͳmetawordʸ, Patched by G-HAL, Mon,17 Nov,2008 */
  struct meta_word* mw1_left;	/**< OCHAIREؽͳκ¦metaword, Patched by G-HAL, Fri,14 Nov,2008 */
  struct meta_word *mw1, *mw2;
  xstr cand_hint;
  int	cand_hint_freq;			/**< cand_hint μǤ, Patched by G-HAL, Thu,20 Nov,2008 */
  int	cand_hint_depth_of_dep;	/**< cand_hint °ο, Patched by G-HAL, Thu,20 Nov,2008 */
  int	cand_hint_length_of_dep;	/**< cand_hint °ʸ, Patched by G-HAL, Sat,24 Jan,2009 */

  int nr_parts;

  /* listΥ */
  struct meta_word *next;
};

int anthy_init_splitter(void);
void anthy_quit_splitter(void);

void anthy_init_split_context(xstr *xs, struct splitter_context *, int is_reverse);
/*
 * mark_border(context, l1, l2, r1);
 * l1r1δ֤ʸ򸡽Ф롢l1l2δ֤϶ˤʤ
 */
void anthy_mark_border(struct splitter_context *, int from, int from2, int to);
#if 0	/* Patched by G-HAL, Thu,27 Nov,2008 */
void anthy_commit_border(struct splitter_context *, int nr,
		   struct meta_word **mw, int *len);
#else
void anthy_commit_border( struct splitter_context* const sc, int nr_segments,
						 struct meta_word* const * const mw, const int* const seg_len,
						 const unsigned int* const extra_flag );
#endif
void anthy_release_split_context(struct splitter_context *c);

/* Фʸξ */
int anthy_get_nr_metaword(struct splitter_context *, int from, int len);
struct meta_word *anthy_get_nth_metaword(struct splitter_context *,
					 int from, int len, int nth);
/**/
int anthy_dep_word_hash(xstr *xs);


#ifdef __cplusplus
}
#endif

#endif
