/*
 * Ψɾӥӥ르ꥺ(viterbi algorithm)ˤä
 * ʸζڤꤷƥޡ롣
 *
 *
 * ƤӽФؿ
 *  anthy_mark_borders()
 *
 * Copyright (C) 2006-2007 TABATA Yusuke
 * Copyright (C) 2004-2006 YOSHIDA Yuichi
 * Copyright (C) 2006 HANAOKA Toshiyuki
 *
 */
/*
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
 * ƥ¸ߤmeta_wordĤʤǥդޤ
 * (ΥդΤȤƥ(lattice/«)⤷ϥȥꥹ(trellis)ȸƤӤޤ)
 * meta_wordɤ³դΥΡɤȤʤꡢ¤lattice_node
 * 󥯤Ȥƹޤ
 *
 * ǤνϼĤǤǹޤ
 * (1) դĤġƥΡɤؤãΨ
 * (2) դ()餿ɤäƺŬʥѥ
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>		/* Patched by G-HAL, Thu,20 Nov,2008 */

#include "anthy/settings.h"	/* Patched by G-HAL, Fri,17 Oct,2008 */
#include <anthy/alloc.h>
#include <anthy/xstr.h>
#include <anthy/segclass.h>
#include <anthy/splitter.h>
#include <anthy/feature_set.h>
#include <anthy/diclib.h>
#include "anthy/logger.h"	/* Patched by G-HAL, Tue,03 Feb,2009 */
#include "anthy/record.h"	/* Patched by G-HAL, Tue,03 Feb,2009 */
#include "src-worddic/dic_ent.h"	/* Patched by G-HAL, Thu,29 Jan,2009 */
#include "anthy/ordering.h"	/* Patched by G-HAL, Wed,04 Feb,2009 */
#include "wordborder.h"

static float anthy_normal_length = 20.0; /* ʸδԤĹ */
static void *trans_info_array;

#define NODE_MAX_SIZE 50

/* դΥΡ(ܾ) */
struct lattice_node {
  int border; /* ʸΤɤϤޤ֤ */
  enum seg_class seg_class; /* ξ֤ʻ */


  double real_probability;  /* ˻ޤǤγΨ(ʸ̵) */
  double adjusted_probability;  /* ˻ޤǤγΨ(ʸͭ) */


  struct lattice_node* before_node; /* ܾ */
  struct meta_word* mw; /* ܾ֤бmeta_word */

  struct lattice_node* next; /* ꥹȹ¤ΤΥݥ */
};

struct node_list_head {
  struct lattice_node *head;
  int nr_nodes;
};

struct lattice_info {
  /* ܾ֤ΥꥹȤ */
  struct node_list_head *lattice_node_list;
  struct splitter_context *sc;
  /* ΡɤΥ */
  allocator node_allocator;
};

/*
 */
static void
print_lattice_node(struct lattice_info *info, struct lattice_node *node)
{
  if (!node) {
    printf("**lattice_node (null)*\n");
    return ;
  }
  printf("**lattice_node probability=%.128f\n", node->real_probability);
  if (node->mw) {
    anthy_print_metaword(info->sc, node->mw);
  }
}

static double
get_poisson(double lambda, int r)
{
  int i;
  double result;

  /* פ˥ݥ諒ʬ */
  result = pow(lambda, (double)r) * exp(-lambda);
  for (i = 2; i <= r; ++i) {
    result /= i;
  }

  return result;
}

/* ʸη饹Ĵ */
static double
get_form_bias(struct meta_word *mw)
{
  double bias;
  int r;
  /* wrapƤΤȤ */
  while (mw->type == MW_WRAP) {
    mw = mw->mw1;
  }
  /* ʸĹˤĴ */
  r = mw->len;
  if (r > 6) {
    r = 6;
  }
  if (r < 2) {
    r = 2;
  }
  if (mw->seg_class == SEG_RENTAI_SHUSHOKU &&
      r < 3) {
    /* ؼ */
    r = 3;
  }
  bias = get_poisson(anthy_normal_length, r);
  return bias;
}

static void
build_feature_list(struct lattice_node *node,
		   struct feature_list *features)
{
  int pc, cc;
  if (node) {
    cc = node->seg_class;
  } else {
    cc = SEG_TAIL;
  }
  anthy_feature_list_set_cur_class(features, cc);
  if (node && node->before_node) {
    pc = node->before_node->seg_class;
  } else {
    pc = SEG_HEAD;
  }
  anthy_feature_list_set_class_trans(features, pc, cc);

  if (node && node->mw) {
    struct meta_word *mw = node->mw;
    anthy_feature_list_set_dep_class(features, mw->dep_class);
    anthy_feature_list_set_dep_word(features,
				    mw->dep_word_hash);
    anthy_feature_list_set_mw_features(features, mw->mw_features);
    anthy_feature_list_set_noun_cos(features, mw->core_wt);

  }
  anthy_feature_list_sort(features);
}

static double
calc_probability(int cc, struct feature_list *fl)
{
  struct feature_freq *res, arg;
  double prob;

  /* Ψ׻ */
  res = anthy_find_feature_freq(trans_info_array,
				fl, &arg);
  prob = 0;
  if (res) {
    double pos = res->f[15];
    double neg = res->f[14];
    prob = 1 - (neg) / (double) (pos + neg);
  }
  if (prob <= 0) {
    /* ʸ¸ߤʤѥʤΤ0˶ᤤ */
    prob = 1.0f / (double)(10000 * 100);
  }

  if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
    anthy_feature_list_print(fl);
    printf(" cc=%d(%s), P=%f\n", cc, anthy_seg_class_name((enum seg_class)cc), prob);
  }
  return prob;
}

static double
get_transition_probability(struct lattice_node *node)
{
  struct feature_list features;
  double probability;

  /**/
  anthy_feature_list_init(&features);
  build_feature_list(node, &features);
  probability = calc_probability(node->seg_class, &features);
  anthy_feature_list_free(&features);

  /* ʸηФɾ */
  probability *= get_form_bias(node->mw);
  return probability;
}

static struct lattice_info*
alloc_lattice_info(struct splitter_context *sc, int size)
{
  int i;
  struct lattice_info* info = (struct lattice_info*)malloc(sizeof(struct lattice_info));
  info->sc = sc;
  info->lattice_node_list = (struct node_list_head*)
    malloc((size + 1) * sizeof(struct node_list_head));
  for (i = 0; i < size + 1; i++) {
    info->lattice_node_list[i].head = NULL;
    info->lattice_node_list[i].nr_nodes = 0;
  }
  info->node_allocator = anthy_create_allocator(sizeof(struct lattice_node),
						NULL);
  return info;
}

/** metaword ɾ׻
 *@param[in]		sc			ϥǡ
 *@param[in]		mw			ʸ
 *@param[in]		prev_mw			ʸ
 *@return					ɾ
 *
 *	Patched by G-HAL
 *		Sun,16 Nov,2008
 *		Thu,20 Nov,2008
 *		Tue,03 Feb,2009
 *		Wed,04 Feb,2009
 */
int calc_metaword_score( const struct splitter_context* const sc,
		    struct meta_word* const mw,
		    const struct meta_word* const prev_mw )
{
  int		score = 0;
  if (NULL == mw) {
    return 0;
  }

  /* δܷ׻ */
  if (anthy_settings.anthy_mode.lattice.with_cand_score) {
    score = mw->cand_hint_freq;
  } else {
    score = mw->score;
  }
  if (anthy_settings.anthy_mode.lattice.with_candstruct_score) {
    anthy_mw_eval( mw, (prev_mw ? prev_mw->seg_class : SEG_HEAD), anthy_settings.anthy_mode.lattice.with_cand_corpus );
    score = (int) ((double)score * mw->struct_score / RATIO_BASE);

    /* °ܤ¿ˤϥ򲼤롧Σ */
    if (anthy_settings.anthy_mode.depgraph.score.decrease_biasscore_threshold <= mw->cand_hint_depth_of_dep) {
      score += anthy_settings.anthy_mode.depgraph.score.decrease_biasscore;
    }
    score += (mw->cand_hint_depth_of_dep * anthy_settings.anthy_mode.depgraph.score.decrease_score);
  }
  if (score < 1) {
    score = 1;
  }

  if (anthy_settings.anthy_mode.lattice.with_dep_history) {
    if (-1 == mw->extra_score) {
      mw->extra_score = 0;
      do {
	xstr	xs;
	if (sc->char_count < (mw->from + mw->len - mw->cand_hint_length_of_dep)) {
	  anthy_log( 1, "***BUG*** calc_metaword_score() max:%d, from:%d, len:%d, dep-len:%d\n",
		    sc->char_count, mw->from, mw->len, mw->cand_hint_length_of_dep );
	  break;
	}
	if (anthy_select_section(DEP_HISTORY,0)) {
	  break;
	}
	xs.str = sc->ce[mw->from + mw->len - mw->cand_hint_length_of_dep].c;
	xs.len = mw->cand_hint_length_of_dep;
	if ((0 < xs.len) && !anthy_select_row(&xs,0)) {
	  const int	count = anthy_get_row_frequency();
	  if (0 < count) {
	    mw->extra_score = (int)( (double)anthy_settings.anthy_mode.depgraph.score.increase_biasscore_by_learn
				    * log10( 1.0 + count ) );
	  }
	}
      } while(0);
    }
    score += mw->extra_score;
  }

  return score;
}

#if 0	/* Patched by G-HAL, Wed,04 Feb,2009 */
static void
calc_node_parameters(struct lattice_node *node)
#else
static void calc_node_parameters( struct lattice_node* const node, const struct splitter_context* const sc )
#endif
{
  /* бmetaword̵ʸƬȽǤ */
  node->seg_class = node->mw ? node->mw->seg_class : SEG_HEAD;

  if (node->before_node) {
    /* ܤΡɤ */
    node->real_probability = node->before_node->real_probability *
      get_transition_probability(node);
   #if 0
    node->adjusted_probability = node->real_probability *
	(node->mw ? node->mw->score : 1000);
   #else
    node->adjusted_probability = node->real_probability *
	(node->mw ? calc_metaword_score(sc,node->mw,node->before_node->mw) : 1000);
   #endif
  } else {
    /* ܤΡɤ̵ */
    node->real_probability = 1.0;
    node->adjusted_probability = node->real_probability;
  }
}

static struct lattice_node*
alloc_lattice_node(struct lattice_info *info,
		   struct lattice_node* before_node,
		   struct meta_word* mw, int border)
{
  struct lattice_node* node;
  node = (struct lattice_node*) anthy_smalloc(info->node_allocator);
  node->before_node = before_node;
  node->border = border;
  node->next = NULL;
  node->mw = mw;

 #if 0	/* Patched by G-HAL, Wed,04 Feb,2009 */
  calc_node_parameters(node);
 #else
  calc_node_parameters( node, info->sc );
 #endif

  return node;
}

static void
release_lattice_node(struct lattice_info *info, struct lattice_node* node)
{
  anthy_sfree(info->node_allocator, node);
}

static void
release_lattice_info(struct lattice_info* info)
{
  anthy_free_allocator(info->node_allocator);
  free(info->lattice_node_list);
  free(info);
}

#if 0		/* Patched by G-HAL, Tue,04 Nov,2008 */
static int
cmp_node_by_type(struct lattice_node *lhs, struct lattice_node *rhs,
		 enum metaword_type type)
{
  if (lhs->mw->type == type && rhs->mw->type != type) {
    return 1;
  } else if (lhs->mw->type != type && rhs->mw->type == type) {
    return -1;
  } else {
    return 0;
  }
}
#endif

static int
cmp_node_by_type_to_type(struct lattice_node *lhs, struct lattice_node *rhs,
			 enum metaword_type type1, enum metaword_type type2)
{
  if (lhs->mw->type == type1 && rhs->mw->type == type2) {
    return 1;
  } else if (lhs->mw->type == type2 && rhs->mw->type == type1) {
    return -1;
  } else {
    return 0;
  }
}

#if 0		/* Patched by G-HAL, Tue,04 Nov,2008 */
#else

/** metaword ӤʥȽꤹ
 *@param[in]		lhs_score	Υ
 *@param[in]		rhs_score	Υ
 *@retval		+1		lhs⤤
 *@retval		0		Ʊ
 *@retval		-1		rhs⤤
 *
 *@attention
 *	ͤ +1, 0, -1 ΣѥΤߤǸƤĽ꤬Τա
 *
 *	Patched by G-HAL, Tue,04 Nov,2008
 */
inline int cmp_node_by_score( int lhs_score, int rhs_score )
{
  if (lhs_score > rhs_score) {
    return +1;
  } else if (lhs_score < rhs_score) {
    return -1;
  }
  return 0;
}


/** metaword ̻ͥ
 *
 *	Patched by G-HAL
 *		Thu,29 Jan,2009
 */
struct priority_of_metaword_pair_t {
  const int	pri;			/**< ͥ */
  const int	sub;			/**< sub-priority Ĥݤ */
  const int	autoexpand_deps;	/**< °μưĥǽݤʣʸĹץ⡼ɻΤߡ */
};
/** metaword ͥ
 *
 *@note
 *	ʸڤ⡼ɤоݤˤäƤϡ̤βžΤ
 *
 *	CAND_HISTORYؽ OCHAIREؽиϡ
 *	ʸĹץ⡼ɻΤ߻Ѳǽ
 *	ʥӥӤǤϽ̤βžбʰ١ˡ
 *
 *	üʸڤʤϡ
 *	ʸĹץ⡼ɻΤ߻Ѳǽ
 *	ʥӥӤǤϱüǶڤʤʸбʰ١ˡ
 *
 *	MW_COMPOUND_*  ʸĹץ⡼ɻΤߤʤΤϡ
 *	ñ˥르ꥺνΰ㤤ؤб
 *
 *	Patched by G-HAL
 *		Wed,05 Nov,2008
 *		Sun,16 Nov,2008
 *		Tue,18 Nov,2008
 *		Thu,20 Nov,2008
 *		Mon,05 Jan,2009
 *		Sat,17 Jan,2009
 *		Mon,19 Jan,2009
 *		Sat,24 Jan,2009, Thu,29 Jan,2009
 *		Sun,08 Feb,2009
 */
struct priority_of_metaword_t {
  const struct priority_of_metaword_pair_t	OCHAIRE_MIDDLE;			/**< (37)	OCHAIREؽΡɡʸ */
  const struct priority_of_metaword_pair_t	OCHAIREwoD_MIDDLE;		/**< (36)	°̵OCHAIREؽΡɡʸ */
  const struct priority_of_metaword_pair_t	OCHAIREwoI_MIDDLE;		/**< (35)	Ω̵OCHAIREؽΡɡʸ */
  const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_MIDDLE;		/**< (34)	Ω졦°̵OCHAIREؽΡɡʸ */
  const struct priority_of_metaword_pair_t	CAND_COUNTER_MAXLIMIT;		/**< (29)	CAND_HISTORYؽ OCHAIREؽйξ¡ʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	CAND_COUNTER_MAXLIMIT_VALUE;	/**< (25)	CAND_COUNTER_MAXLIMITŬѤ줿Ѥͥ١ʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	OCHAIRE_HEAD;			/**< (17)-1	OCHAIREؽΡɡƬʸ
										 *   (17)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ */
  const struct priority_of_metaword_pair_t	OCHAIREwoD_HEAD;		/**< (16)-1	°̵OCHAIREؽΡɡƬʸ
										 *   (16)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ */
  const struct priority_of_metaword_pair_t	OCHAIRE_TAIL;			/**< (15)-1	OCHAIREؽΡɡǸʸ
										 *   (15)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
										 */
  const struct priority_of_metaword_pair_t	OCHAIRE_SINGLE;			/**< (14)-1	OCHAIREؽΡɡƬǤĺǸ
										 *   (14)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
										 */
  const struct priority_of_metaword_pair_t	OCHAIREwoI_TAIL;		/**< (14)-1	Ω̵OCHAIREؽΡɡǸʸ
										 *   (14)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
										 */
  const struct priority_of_metaword_pair_t	OCHAIREwoD_TAIL;		/**< (13)-1	°̵OCHAIREؽΡɡǸʸ
										 *   (13)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
										 */
  const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_TAIL;		/**< (12)-1	Ω졦°̵OCHAIREؽΡɡǸʸ
										 *   (12)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
										 */
  const struct priority_of_metaword_pair_t	OCHAIREwoD_SINGLE;		/**< (11)-1	°̵OCHAIREؽΡɡƬǤĺǸ
										 *   (11)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
										 */
  const struct priority_of_metaword_pair_t	CAND_STRONGMODE;		/**< (11)-3	CAND_HISTORYؽΡ(true == anthy_settings.anthy_mode.lattice.with_candhistory) */
  const struct priority_of_metaword_pair_t	CAND_COUNTER_MINLIMIT;		/**< (10)	CAND_HISTORYؽ OCHAIREؽй򳫻Ϥ벼¡ʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	CAND_WEAKMODE;			/**< (5)	CAND_HISTORYؽΡ(false == anthy_settings.anthy_mode.lattice.with_candhistory) */
  const struct priority_of_metaword_pair_t	DEFAULT;			/**< (5)	ƥ༭񤫤Ρɡ¾ */
  const struct priority_of_metaword_pair_t	COMPOUNDHEAD_MAXLEN;		/**< (5)	ƥ༭񤫤ΡɡMW_COMPOUND_HEADʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	COMPOUNDPART_MAXLEN;		/**< (4)	ƥ༭񤫤ΡɡMW_COMPOUND_PARTʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	COMPOUND_MAXLEN;		/**< (2)	ƥ༭񤫤ΡɡMW_COMPOUNDʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	COMPOUNDLEAF_MAXLEN;		/**< (1)	ƥ༭񤫤ΡɡMW_COMPOUND_LEAFʣʸĹץ⡼ɻΤߡ */
  const struct priority_of_metaword_pair_t	OCHAIREwoI_HEAD;		/**< (0)	Ω̵OCHAIREؽΡɡƬʸ */
  const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_HEAD;		/**< (0)	Ω졦°̵OCHAIREؽΡɡƬʸ */
  const struct priority_of_metaword_pair_t	OCHAIREwoI_SINGLE;		/**< (0)	Ω̵OCHAIREؽΡɡƬǤĺǸ */
  const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_SINGLE;		/**< (0)	Ω졦°̵OCHAIREؽΡɡƬǤĺǸ */
  const struct priority_of_metaword_pair_t	DELETEDHISTORY;			/**< (0)	ޡդؽ */
};

const struct {
  const struct priority_of_metaword_t VITERBI;
  const struct priority_of_metaword_t MAXLEN;
} PRIORITY_OF_METAWORD = {
  .VITERBI = {
    .OCHAIRE_MIDDLE              = { .pri = 37, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoD_MIDDLE           = { .pri = 36, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoI_MIDDLE           = { .pri = 35, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_MIDDLE        = { .pri = 34, .sub = 1, .autoexpand_deps = 0, },
    .CAND_COUNTER_MAXLIMIT       = { .pri = 29, .sub = 1, .autoexpand_deps = 0, },
    .CAND_COUNTER_MAXLIMIT_VALUE = { .pri = 25, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIRE_HEAD                = { .pri = 15, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoD_HEAD             = { .pri = 14, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIRE_TAIL                = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIRE_SINGLE              = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoI_TAIL             = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoD_TAIL             = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_TAIL          = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoD_SINGLE           = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .CAND_STRONGMODE             = { .pri = 13, .sub = 0, .autoexpand_deps = 0, },
    .CAND_COUNTER_MINLIMIT       = { .pri = 10, .sub = 0, .autoexpand_deps = 0, },
    .CAND_WEAKMODE               = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .DEFAULT                     = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUNDHEAD_MAXLEN         = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUNDPART_MAXLEN         = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUND_MAXLEN             = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUNDLEAF_MAXLEN         = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoI_HEAD             = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_HEAD          = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoI_SINGLE           = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_SINGLE        = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .DELETEDHISTORY              = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
  },
  .MAXLEN = {
    .OCHAIRE_MIDDLE              = { .pri = 37, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoD_MIDDLE           = { .pri = 36, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoI_MIDDLE           = { .pri = 35, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_MIDDLE        = { .pri = 34, .sub = 1, .autoexpand_deps = 0, },
    .CAND_COUNTER_MAXLIMIT       = { .pri = 29, .sub = 1, .autoexpand_deps = 1, },
    .CAND_COUNTER_MAXLIMIT_VALUE = { .pri = 25, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIRE_HEAD                = { .pri = 17, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIREwoD_HEAD             = { .pri = 16, .sub = 1, .autoexpand_deps = 0, },
    .OCHAIRE_TAIL                = { .pri = 15, .sub = 1, .autoexpand_deps = 1, },
    .OCHAIRE_SINGLE              = { .pri = 14, .sub = 1, .autoexpand_deps = 1, },
    .OCHAIREwoI_TAIL             = { .pri = 14, .sub = 1, .autoexpand_deps = 1, },
    .OCHAIREwoD_TAIL             = { .pri = 13, .sub = 1, .autoexpand_deps = 1, },
    .OCHAIREwoIwoD_TAIL          = { .pri = 12, .sub = 1, .autoexpand_deps = 1, },
    .OCHAIREwoD_SINGLE           = { .pri = 11, .sub = 1, .autoexpand_deps = 1, },
    .CAND_STRONGMODE             = { .pri = 11, .sub = 0, .autoexpand_deps = 1, },
    .CAND_COUNTER_MINLIMIT       = { .pri = 10, .sub = 1, .autoexpand_deps = 1, },
    .CAND_WEAKMODE               = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .DEFAULT                     = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUNDHEAD_MAXLEN         = { .pri =  5, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUNDPART_MAXLEN         = { .pri =  4, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUND_MAXLEN             = { .pri =  2, .sub = 0, .autoexpand_deps = 0, },
    .COMPOUNDLEAF_MAXLEN         = { .pri =  1, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoI_HEAD             = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_HEAD          = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoI_SINGLE           = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .OCHAIREwoIwoD_SINGLE        = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
    .DELETEDHISTORY              = { .pri =  0, .sub = 0, .autoexpand_deps = 0, },
  },
};


/** metaword ͥ٤׻
 *@param[in]		pri			Ѥͥٽɽ
 *@param[in]		mw			ͥ٤metaword
 *@param		cmp_priority		оݤȤʤ priority
 *@param		cmp_minlen		оݤȤʤʸ
 *@param[out]		have_sub_priority	sub-priority Ĥݤ
 *@param[out]		autoexpand_deps		°μưĥǽݤ
 *@param[out]		ret_minlen		Ӵʸоݤ cmp_minlen ȤϤ͡
 *@return					ͥ١礭ۤɹ⤤
 *
 *	(lhs|rhs)->mw->type ˤ MW_OCHAIRE, MW_CANDHISTORY ʳʪ⤢Τա
 *
 *	Patched by G-HAL
 *		Wed,05 Nov,2008
 *		Sun,16 Nov,2008
 *		Tue,18 Nov,2008
 *		Thu,20 Nov,2008
 *		Mon,05 Jan,2009
 *		Sat,17 Jan,2009
 *		Mon,19 Jan,2009
 *		Sat,24 Jan,2009, Thu,29 Jan,2009
 *		Sun,08 Feb,2009
 */
inline int calc_cmpnode_priority( const struct priority_of_metaword_t* const pri,
				 struct meta_word* const mw,
				 int cmp_priority,
				 int cmp_minlen,
				 int* const have_sub_priority,
				 int* const autoexpand_deps,
				 int* const ret_minlen )
{
  if (MW_OCHAIRE == mw->type) {
    if (mw->score <= 0) {
      *ret_minlen = 0;
      *have_sub_priority = pri->DELETEDHISTORY.sub;
      *autoexpand_deps   = pri->DELETEDHISTORY.autoexpand_deps;
      return pri->DELETEDHISTORY.pri;
    }
    if (NULL == mw->mw1_left) {
      if (NULL == mw->mw1) {
	*ret_minlen = mw->len;
	*have_sub_priority = pri->OCHAIRE_SINGLE.sub;
	*autoexpand_deps   = pri->OCHAIRE_SINGLE.autoexpand_deps;
	return pri->OCHAIRE_SINGLE.pri;
      }
      *ret_minlen = mw->ochaire_total_len;
      *have_sub_priority = pri->OCHAIRE_HEAD.sub;
      *autoexpand_deps   = pri->OCHAIRE_HEAD.autoexpand_deps;
      return pri->OCHAIRE_HEAD.pri;
    }
    if (NULL == mw->mw1) {
      *ret_minlen = mw->len;
      *have_sub_priority = pri->OCHAIRE_TAIL.sub;
      *autoexpand_deps   = pri->OCHAIRE_TAIL.autoexpand_deps;
      return pri->OCHAIRE_TAIL.pri;
    }
    *ret_minlen = mw->ochaire_total_len;
    *have_sub_priority = pri->OCHAIRE_MIDDLE.sub;
    *autoexpand_deps   = pri->OCHAIRE_MIDDLE.autoexpand_deps;
    return pri->OCHAIRE_MIDDLE.pri;
  }
  if (MW_OCHAIREwithoutINDEP == mw->type) {
    if (mw->score <= 0) {
      *ret_minlen = 0;
      *have_sub_priority = pri->DELETEDHISTORY.sub;
      *autoexpand_deps   = pri->DELETEDHISTORY.autoexpand_deps;
      return pri->DELETEDHISTORY.pri;
    }
    if (NULL == mw->mw1_left) {
      if (NULL == mw->mw1) {
	*ret_minlen = mw->len;
	*have_sub_priority = pri->OCHAIREwoI_SINGLE.sub;
	*autoexpand_deps   = pri->OCHAIREwoI_SINGLE.autoexpand_deps;
	return pri->OCHAIREwoI_SINGLE.pri;
      }
      *ret_minlen = mw->ochaire_total_len;
      *have_sub_priority = pri->OCHAIREwoI_HEAD.sub;
      *autoexpand_deps   = pri->OCHAIREwoI_HEAD.autoexpand_deps;
      return pri->OCHAIREwoI_HEAD.pri;
    }
    if (NULL == mw->mw1) {
      *ret_minlen = mw->len;
      *have_sub_priority = pri->OCHAIREwoI_TAIL.sub;
      *autoexpand_deps   = pri->OCHAIREwoI_TAIL.autoexpand_deps;
      return pri->OCHAIREwoI_TAIL.pri;
    }
    *ret_minlen = mw->ochaire_total_len;
    *have_sub_priority = pri->OCHAIREwoI_MIDDLE.sub;
    *autoexpand_deps   = pri->OCHAIREwoI_MIDDLE.autoexpand_deps;
    return pri->OCHAIREwoI_MIDDLE.pri;
  }
  if (MW_OCHAIREwithoutDEP == mw->type) {
    if (mw->score <= 0) {
      *ret_minlen = 0;
      *have_sub_priority = pri->DELETEDHISTORY.sub;
      *autoexpand_deps   = pri->DELETEDHISTORY.autoexpand_deps;
      return pri->DELETEDHISTORY.pri;
    }
    if (NULL == mw->mw1_left) {
      if (NULL == mw->mw1) {
	*ret_minlen = mw->len;
	*have_sub_priority = pri->OCHAIREwoD_SINGLE.sub;
	*autoexpand_deps   = pri->OCHAIREwoD_SINGLE.autoexpand_deps;
	return pri->OCHAIREwoD_SINGLE.pri;
      }
      *ret_minlen = mw->ochaire_total_len;
      *have_sub_priority = pri->OCHAIREwoD_HEAD.sub;
      *autoexpand_deps   = pri->OCHAIREwoD_HEAD.autoexpand_deps;
      return pri->OCHAIREwoD_HEAD.pri;
    }
    if (NULL == mw->mw1) {
      *ret_minlen = mw->len;
      *have_sub_priority = pri->OCHAIREwoD_TAIL.sub;
      *autoexpand_deps   = pri->OCHAIREwoD_TAIL.autoexpand_deps;
      return pri->OCHAIREwoD_TAIL.pri;
    }
    *ret_minlen = mw->ochaire_total_len;
    *have_sub_priority = pri->OCHAIREwoD_MIDDLE.sub;
    *autoexpand_deps   = pri->OCHAIREwoD_MIDDLE.autoexpand_deps;
    return pri->OCHAIREwoD_MIDDLE.pri;
  }
  if (MW_OCHAIREwithoutINDEPwithoutDEP == mw->type) {
    if (mw->score <= 0) {
      *ret_minlen = 0;
      *have_sub_priority = pri->DELETEDHISTORY.sub;
      *autoexpand_deps   = pri->DELETEDHISTORY.autoexpand_deps;
      return pri->DELETEDHISTORY.pri;
    }
    if (NULL == mw->mw1_left) {
      if (NULL == mw->mw1) {
	*ret_minlen = mw->len;
	*have_sub_priority = pri->OCHAIREwoIwoD_SINGLE.sub;
	*autoexpand_deps   = pri->OCHAIREwoIwoD_SINGLE.autoexpand_deps;
	return pri->OCHAIREwoIwoD_SINGLE.pri;
      }
      *ret_minlen = mw->ochaire_total_len;
      *have_sub_priority = pri->OCHAIREwoIwoD_HEAD.sub;
      *autoexpand_deps   = pri->OCHAIREwoIwoD_HEAD.autoexpand_deps;
      return pri->OCHAIREwoIwoD_HEAD.pri;
    }
    if (NULL == mw->mw1) {
      *ret_minlen = mw->len;
      *have_sub_priority = pri->OCHAIREwoIwoD_TAIL.sub;
      *autoexpand_deps   = pri->OCHAIREwoIwoD_TAIL.autoexpand_deps;
      return pri->OCHAIREwoIwoD_TAIL.pri;
    }
    *ret_minlen = mw->ochaire_total_len;
    *have_sub_priority = pri->OCHAIREwoIwoD_MIDDLE.sub;
    *autoexpand_deps   = pri->OCHAIREwoIwoD_MIDDLE.autoexpand_deps;
    return pri->OCHAIREwoIwoD_MIDDLE.pri;
  }
  if (MW_CANDHISTORY == mw->type) {
    if (mw->score <= 0) {
      *ret_minlen = 0;
      *have_sub_priority = pri->DELETEDHISTORY.sub;
      *autoexpand_deps   = pri->DELETEDHISTORY.autoexpand_deps;
      return pri->DELETEDHISTORY.pri;
    }
    if ((pri->CAND_COUNTER_MINLIMIT.pri <= cmp_priority) && (cmp_minlen <= mw->len)) {
      if (pri->CAND_COUNTER_MAXLIMIT.pri < cmp_priority) {
	cmp_priority = pri->CAND_COUNTER_MAXLIMIT_VALUE.pri;
      }
      if (mw->ochaire_opposite < cmp_priority) {
	mw->ochaire_opposite = cmp_priority;
      }
    }
    if (0 < mw->ochaire_opposite) {
      *ret_minlen = mw->len;
      *have_sub_priority = pri->CAND_COUNTER_MINLIMIT.sub;
      *autoexpand_deps   = pri->CAND_COUNTER_MINLIMIT.autoexpand_deps;
      return mw->ochaire_opposite;
    }
    if (anthy_settings.anthy_mode.lattice.with_candhistory) {
      *ret_minlen = mw->len;
      *have_sub_priority = pri->CAND_STRONGMODE.sub;
      *autoexpand_deps   = pri->CAND_STRONGMODE.autoexpand_deps;
      return pri->CAND_STRONGMODE.pri;
    }
    *have_sub_priority = pri->CAND_WEAKMODE.sub;
    *autoexpand_deps   = pri->CAND_WEAKMODE.autoexpand_deps;
    return pri->CAND_WEAKMODE.pri;
  }
  if (MW_COMPOUND_HEAD == mw->type) {
    *have_sub_priority = pri->COMPOUNDHEAD_MAXLEN.sub;
    *autoexpand_deps   = pri->COMPOUNDHEAD_MAXLEN.autoexpand_deps;
    return pri->COMPOUNDHEAD_MAXLEN.pri;
  }
  if (MW_COMPOUND_PART == mw->type) {
    *have_sub_priority = pri->COMPOUNDPART_MAXLEN.sub;
    *autoexpand_deps   = pri->COMPOUNDPART_MAXLEN.autoexpand_deps;
    return pri->COMPOUNDPART_MAXLEN.pri;
  }
  if (MW_COMPOUND == mw->type) {
    *have_sub_priority = pri->COMPOUND_MAXLEN.sub;
    *autoexpand_deps   = pri->COMPOUND_MAXLEN.autoexpand_deps;
    return pri->COMPOUND_MAXLEN.pri;
  }
  if (MW_COMPOUND_LEAF == mw->type) {
    *have_sub_priority = pri->COMPOUNDLEAF_MAXLEN.sub;
    *autoexpand_deps   = pri->COMPOUNDLEAF_MAXLEN.autoexpand_deps;
    return pri->COMPOUNDLEAF_MAXLEN.pri;
  }
  *have_sub_priority = pri->DEFAULT.sub;
  *autoexpand_deps   = pri->DEFAULT.autoexpand_deps;
  return pri->DEFAULT.pri;
}

/** ΡɤӤʥӥѡ
 *@param[in]		lhs		ΥΡ
 *@param[in]		rhs		ΥΡ
 *@retval		+1		lhsΨ⤤
 *@retval		0		Ʊ
 *@retval		-1		rhsΨ⤤
 *
 *@attention
 *	ͤ +1, 0, -1 ΣѥΤߤǸƤĽ꤬Τա
 *
 *	Patched by G-HAL
 *		Tue,04 Nov,2008
 *		Wed,05 Nov,2008
 *		Sun,16 Nov,2008
 */
static int
cmp_node_priority_for_viterbi( struct lattice_node* const lhs,
		  struct lattice_node* const rhs )
{
  int		have_sub_priority = 0;
  int		autoexpand_deps = 0;
  int		rhs_minlen = 0;
  int		lhs_minlen = 0;
  const int	rhs_priority_tmp = calc_cmpnode_priority( &PRIORITY_OF_METAWORD.VITERBI, rhs->mw, 0, 0, &have_sub_priority, &autoexpand_deps, &rhs_minlen );
  const int	lhs_priority = calc_cmpnode_priority( &PRIORITY_OF_METAWORD.VITERBI, lhs->mw, rhs_priority_tmp, rhs_minlen, &have_sub_priority, &autoexpand_deps, &lhs_minlen );
  const int	rhs_priority = calc_cmpnode_priority( &PRIORITY_OF_METAWORD.VITERBI, rhs->mw, lhs_priority    , lhs_minlen, &have_sub_priority, &autoexpand_deps, &rhs_minlen );
  if (lhs_priority > rhs_priority) {
    return +1;
  } else if (lhs_priority < rhs_priority) {
    return -1;
  }
  if (have_sub_priority) {
    return cmp_node_by_score( lhs->mw->score, rhs->mw->score );
  }

  {	/* COMPOUND_PARTCOMPOUND_HEADͥ */
    const int ret = cmp_node_by_type_to_type( lhs, rhs, MW_COMPOUND_HEAD, MW_COMPOUND_PART );
    if (ret != 0) return ret;
  }

  return 0;
}
#endif

/*
 * ΡɤӤ
 *
 ** ֤
 * 1: lhsΨ⤤
 * 0: Ʊ
 * -1: rhsΨ⤤
 */
static int
cmp_node(struct lattice_node *lhs, struct lattice_node *rhs)
{
  struct lattice_node *lhs_before = lhs;
  struct lattice_node *rhs_before = rhs;
  int ret;

  if (lhs && !rhs) return 1;
  if (!lhs && rhs) return -1;
  if (!lhs && !rhs) return 0;

  while (lhs_before && rhs_before) {
    if (lhs_before->mw && rhs_before->mw &&
	lhs_before->mw->from + lhs_before->mw->len == rhs_before->mw->from + rhs_before->mw->len) {
      /* Ρɾ Patched by G-HAL, Tue,04 Nov,2008, Sun,16 Nov,2008 */
      ret = cmp_node_priority_for_viterbi( lhs_before, rhs_before );
      if (ret != 0) return ret;
    } else {
      break;
    }
    lhs_before = lhs_before->before_node;
    rhs_before = rhs_before->before_node;
  }

  /* ǸܳΨ򸫤 */
  if (lhs->adjusted_probability > rhs->adjusted_probability) {
    return 1;
  } else if (lhs->adjusted_probability < rhs->adjusted_probability) {
    return -1;
  } else {
    return 0;
  }
}

/*
 * Υƥ˥Ρɤɲä
 */
static void
push_node(struct lattice_info* info, struct lattice_node* new_node,
	  int position)
{
  struct lattice_node* node;
  struct lattice_node* previous_node = NULL;

  if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
    print_lattice_node(info, new_node);
  }

  /* Ƭnode̵̵ɲ */
  node = info->lattice_node_list[position].head;
  if (!node) {
    info->lattice_node_list[position].head = new_node;
    info->lattice_node_list[position].nr_nodes ++;
    return;
  }

  while (node->next) {
    /* ;פʥΡɤɲäʤλ޴ */
    if (new_node->seg_class == node->seg_class &&
	new_node->border == node->border) {
      /* segclassƱǡϤޤ֤Ʊʤ */
      switch (cmp_node(new_node, node)) {
      case 0:
      case 1:
	/* Ψ礭ؽˤΤʤ顢ŤΤ֤*/
	if (previous_node) {
	  previous_node->next = new_node;
	} else {
	  info->lattice_node_list[position].head = new_node;
	}
	new_node->next = node->next;
	release_lattice_node(info, node);
	break;
      case -1:
	/* Ǥʤʤ */
	release_lattice_node(info, new_node);
	break;
      }
      return;
    }
    previous_node = node;
    node = node->next;
  }

  /* ǸΥΡɤθɲ */
  node->next = new_node;
  info->lattice_node_list[position].nr_nodes ++;
}

/* ֳΨ㤤Ρɤõ*/
static void
remove_min_node(struct lattice_info *info, struct node_list_head *node_list)
{
  struct lattice_node* node = node_list->head;
  struct lattice_node* previous_node = NULL;
  struct lattice_node* min_node = node;
  struct lattice_node* previous_min_node = NULL;

  /* ֳΨ㤤Ρɤõ */
  while (node) {
    if (cmp_node(node, min_node) < 0) {
      previous_min_node = previous_node;
      min_node = node;
    }
    previous_node = node;
    node = node->next;
  }

  /* ֳΨ㤤Ρɤ */
  if (previous_min_node) {
    previous_min_node->next = min_node->next;
  } else {
    node_list->head = min_node->next;
  }
  release_lattice_node(info, min_node);
  node_list->nr_nodes --;
}

/* ӥӥ르ꥺѤƷϩ */
static void
choose_path(struct lattice_info* info, int to)
{
  /* ǸޤãܤΤʤǰֳΨ礭Τ */
  struct lattice_node* node;
  struct lattice_node* best_node = NULL;
  int last = to;
  while (!info->lattice_node_list[last].head) {
    /* ǸʸޤܤƤʤä */
    --last;
  }
  for (node = info->lattice_node_list[last].head; node; node = node->next) {
    if (cmp_node(node, best_node) > 0) {
      best_node = node;
    }
  }
  if (!best_node) {
    return;
  }

  /* ܤդˤɤĤʸڤܤϿ */
  node = best_node;
  if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
    printf("choose_path()\n");
  }
  while (node->before_node) {
    info->sc->word_split_info->best_seg_class[node->border] =
      node->seg_class;
    anthy_mark_border_by_metaword(info->sc, node->mw);
    /**/
    if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
      print_lattice_node(info, node);
    }
    /**/
    node = node->before_node;
  }
}

static void
build_graph(struct lattice_info* info, int from, int to)
{
  int i;
  struct lattice_node* node;
  struct lattice_node* left_node;

  /* ȤʤΡɤɲ */
  node = alloc_lattice_node(info, NULL, NULL, from);
  push_node(info, node, from);

  /* info->lattice_node_list[index]ˤindexޤǤܤäƤΤǤäơ
   * indexܤäƤΤǤϤʤ
   */

  /* Ƥܤ򺸤 */
  for (i = from; i < to; ++i) {
    for (left_node = info->lattice_node_list[i].head; left_node;
	 left_node = left_node->next) {
      struct meta_word *mw;
      /* iʸܤãlattice_nodeΥ롼 */

      for (mw = info->sc->word_split_info->cnode[i].mw; mw; mw = mw->next) {
	int position;
	struct lattice_node* new_node;
	/* iʸܤmeta_wordΥ롼 */

	if (mw->can_use != ok) {
	  continue; /* 줿ʸζڤޤmetawordϻȤʤ */
	}
	position = i + mw->len;
	new_node = alloc_lattice_node(info, left_node, mw, i);
	push_node(info, new_node, position);

	/* θ䤬¿顢Ψ㤤 */
	if (info->lattice_node_list[position].nr_nodes >= NODE_MAX_SIZE) {
	  remove_min_node(info, &info->lattice_node_list[position]);
	}
      }
    }
  }

  /* ʸ */
  for (node = info->lattice_node_list[to].head; node; node = node->next) {
    struct feature_list features;
    anthy_feature_list_init(&features);
    build_feature_list(NULL, &features);
    node->adjusted_probability = node->adjusted_probability *
      calc_probability(SEG_TAIL, &features);
    anthy_feature_list_free(&features);
  }
}



#if 1		/* Patched by G-HAL, Sun,16 Nov,2008 */
/** ʸꥹ */
struct maxlen_n_phrases_node_t {
  struct maxlen_n_phrases_node_t*	parent;		/**< ƥΡ */
  struct maxlen_n_phrases_node_t*	child_strong;	/**< ҥΡɡʺǹɾʪ */
  struct maxlen_n_phrases_node_t*	child_normal;	/**< ҥΡɡʷ */
  struct maxlen_n_phrases_node_t*	child_weak;	/**< ҥΡɡͽ */
  struct maxlen_n_phrases_node_t*	prev;		/**< Ρ */
  struct maxlen_n_phrases_node_t*	next;		/**< Ρ */
  struct meta_word*			mw;		/**<  meta_word */
  ssize_t				from;		/**< ʸ */
  size_t				to;		/**< λʸ */
  size_t				len;		/**< 餳ΥΡκǸʸޤǤιʸ */
  size_t				depth;		/**< 餳ΥΡκǸʸޤǤι׿ */
};


/** ʸꥹȤ򣱤䤹
 *@param[in,out]	parent	ʸꥹ
 *@param[in,out]	node_p	䤷ʸΥݥ󥿤γǼ
 *@param[in,out]	prev	ʸꥹ
 *@return			䤷ʸꥹ
 *
 *	Patched by G-HAL, Sun,16 Nov,2008
 */
static struct maxlen_n_phrases_node_t*
alloc_maxlen_n_phrases_node( struct maxlen_n_phrases_node_t* const parent,
			    struct maxlen_n_phrases_node_t** const node_p,
			    struct maxlen_n_phrases_node_t* const prev )
{
  struct maxlen_n_phrases_node_t* const	ret = (struct maxlen_n_phrases_node_t* const) malloc( sizeof(struct maxlen_n_phrases_node_t) );

  if (node_p && (NULL == *node_p)) {
    *node_p = ret;
  }
  ret->parent     = parent;
  ret->child_strong = NULL;
  ret->child_normal = NULL;
  ret->child_weak   = NULL;

  ret->prev = prev;
  if (prev) {
    ret->next  = prev->next;
    prev->next = ret;
    if (ret->next) {
      ret->next->prev = ret;
    }
  } else {
    ret->next = NULL;
  }

  ret->mw    = NULL;
  ret->from  = 0;
  ret->to    = 0;
  ret->len   = 0;
  ret->depth = 0;

  return ret;
}

/** ʸꥹȤ
 *@param[in]		node_p	ʸꥹ
 *
 *	Patched by G-HAL, Sun,16 Nov,2008
 */
static void free_maxlen_n_phrases_node( struct maxlen_n_phrases_node_t** const node_p )
{
  struct maxlen_n_phrases_node_t*	node = *node_p;
  struct maxlen_n_phrases_node_t*	next;
  *node_p = NULL;

  if (NULL == node) {
    return;
  }
  while (node->prev) {
    node = node->prev;
  }
  while (node) {
    free_maxlen_n_phrases_node( &(node->child_strong) );
    free_maxlen_n_phrases_node( &(node->child_normal) );
    free_maxlen_n_phrases_node( &(node->child_weak  ) );
    next = node->next;
    free( node );
    node = next;
  }
  return;
}

/** ʸꥹȤڤΥ
 *@param[in]		node	ʸꥹ
 *
 *	Patched by G-HAL, Sun,16 Nov,2008
 */
static void delink_maxlen_n_phrases_node( struct maxlen_n_phrases_node_t* const node )
{
  if (node->parent->child_strong == node) {
    node->parent->child_strong = node->prev ? node->prev : node->next;
  }
  free_maxlen_n_phrases_node( &(node->child_strong) );
  if (node->parent->child_normal == node) {
    node->parent->child_normal = node->prev ? node->prev : node->next;
  }
  free_maxlen_n_phrases_node( &(node->child_normal) );
  if (node->parent->child_weak == node) {
    node->parent->child_weak = node->prev ? node->prev : node->next;
  }
  free_maxlen_n_phrases_node( &(node->child_weak) );

  if (node->prev) {
    node->prev->next = node->next;
  }
  if (node->next) {
    node->next->prev = node->prev;
  }
  free( node );

  return;
}

/** build_path_by_maxlen_n_phrases() ǺäꥹȤλ޴
 *@param[in,out]	node			ʸꥹ
 *@param		maxdepth		޴ο줿
 *@param		maxlen			޴͡줿Ĺʸ
 *
 *	Patched by G-HAL
 *		Sun,16 Nov,2008 - Sat,22 Nov,2008
 */
static void cut_path_by_maxlen_n_phrases( struct maxlen_n_phrases_node_t* node,
					 size_t maxdepth, size_t maxlen )
{
  struct maxlen_n_phrases_node_t*	next;

  if (NULL == node) {
    return;
  }

  while (node) {
    next = node->next;
    if (node->child_strong) {
      if (maxdepth <= node->depth) {
	free_maxlen_n_phrases_node( &(node->child_strong) );
	/* ա node->child_strong 񤭴 */
      } else {
	cut_path_by_maxlen_n_phrases( node->child_strong, maxdepth, maxlen );
	/* ա node->child_strong 񤭴 */
      }
    }
    if (node->child_normal) {
      if (maxdepth <= node->depth) {
	free_maxlen_n_phrases_node( &(node->child_normal) );
	/* ա node->child_normal 񤭴 */
      } else {
	cut_path_by_maxlen_n_phrases( node->child_normal, maxdepth, maxlen );
	/* ա node->child_normal 񤭴 */
      }
    }
    if (node->child_weak) {
      if (maxdepth <= node->depth) {
	free_maxlen_n_phrases_node( &(node->child_weak) );
	/* ա node->child_weak 񤭴 */
      } else {
	cut_path_by_maxlen_n_phrases( node->child_weak, maxdepth, maxlen );
	/* ա node->child_weak 񤭴 */
      }
    }
    if ((NULL == node->child_strong) && (NULL == node->child_normal) && (NULL == node->child_weak)) {
      if (node->len < maxlen) {
	if (node->parent->child_strong == node) {
	  /* Ǿäʤ */
	} else {
	  delink_maxlen_n_phrases_node( node );
	}
      }
    }
    node = next;
  }
  return;
}


/** ¦ʸڤ꤬ꤵ줿 mw κ¦ʸȰפ뤫ɤȽꤹ
 *@param[in]		sc			ʸڤ
 *@param[in]		parent			ʸڤ
 *@param[in]		mw			ȽȤ mw
 *@retval		0			פʤ
 *@retval		1			פ
 *
 *	Patches by G-HAL
 *		Sun,16 Nov,2008
 */
static int check_is_match_leftmw( const struct splitter_context* sc,
				 const struct maxlen_n_phrases_node_t* parent,
				 const struct meta_word* mw )
{
  struct word_split_info_cache*		info = sc->word_split_info;
  size_t	i;

  if (NULL == mw) {
    return 0;
  }
  mw = mw->mw1_left;

  while (mw) {
   #if 0
    /* ʸẸڤΥå */
    if (parent && (0 <= parent->from)) {
      if (parent->from != mw->from) {
	return 0;
      }
    } else {
      if (0 == info->seg_border[mw->from]) {
	return 0;
      }
    }
   #endif
    /* ʸΥå */
    for (i = mw->from + mw->len - 1; mw->from < i; --i) {
      if (0 != info->seg_border[i]) {
	return 0;
      }
    }
    /* ʸᱦڤΥå */
    if (parent && parent->mw) {
      if (parent->to != (mw->from + mw->len)) {
	return 0;
      }
    } else {
      if (0 == info->seg_border[mw->from + mw->len]) {
	return 0;
      }
    }
    /*  */
    mw = mw->mw1_left;
    if (parent) {
      parent = parent->parent;
    }
  }
  return 1;
}

/** mw  cand ʬʸȤƻäƤ뤫ݤȽꤹ
 *@param[in]		yomi			ʸʤߤʡ
 *@param[in]		cand			ʸѴ
 *@param		cand_from		Ƚ곫ϰ֡cand 
 *@param[in]		mw			 mw
 *@param[in,out]	cmped_cand_len		ȽꤷĹcand ˡNULLʤ̵
 *@retval		0			
 *@retval		1			
 *
 *@note
 *	Ǥ Anthy ߷פǤϡʸڤλǤ϶ŪѴʤͤˤʤäƤ롣
 *	ʤ餳δؿǤϡmw ŪѴ䤬cand ޤफɤȽꤹ٤ˡ
 *	虜虜ѴʤФʤʤ
 *
 *@attention
 *	mw ʣѥʸľ礬롣
 *	ξϡɤ줫ѥǤפп֤
 *
 *	Patches by G-HAL
 *		Thu,29 Jan,2009
 */
static int mw_is_match_xstr( const xchar* const yomi, const xstr* const cand, int cand_from, const struct meta_word* const mw, int* const cmped_cand_len )
{
  if ((NULL == yomi) || (NULL == cand) || (cand_from < 0) || (NULL == mw)) {
    return 0;
  }
  if (cand->len <= cand_from) {
    return 0;
  }

  if (mw->cand_hint.str && (0 < mw->cand_hint.len)) {
    xstr tmp1;
    xstr tmp2;
    tmp1.len = cand->len - cand_from;
    tmp1.str = &(cand->str[cand_from]);
    tmp2.len = mw->cand_hint.len;
    tmp2.str = mw->cand_hint.str;
    if (tmp1.len <= tmp2.len) {
      tmp2.len = tmp1.len;
    } else {
      tmp1.len = tmp2.len;
    }
    if (cmped_cand_len) {
      *cmped_cand_len = tmp2.len;
    }
    if (0 != anthy_xstrcmp( &tmp1, &tmp2 )) {
      return 0;
    }

  } else if (mw->wl && mw->wl->len) {
    int i, j;
    xstr tmp1;
    xstr tmp2;
    for (i = 0; i < mw->nr_parts; ++i) {
      const struct part_info* const part = &(mw->wl->part[i]);
      const struct seq_ent* const s = part->seq;
      if (part->len <= 0) {
	continue;
      }
      if (s) {
	wtype_t wt = anthy_get_wtype_with_ct( part->wt, CT_NONE );
	for (j = 0; j < s->nr_dic_ents; ++j) {
	  if (!anthy_wtype_include(wt, s->dic_ents[j]->type)) {
	    continue;
	  }
	  tmp1.len = cand->len - cand_from;
	  tmp1.str = &(cand->str[cand_from]);
	  tmp2.len = s->dic_ents[j]->str.len;
	  tmp2.str = s->dic_ents[j]->str.str;
	  if (tmp1.len <= tmp2.len) {
	    tmp2.len = tmp1.len;
	  } else {
	    tmp1.len = tmp2.len;
	  }
	  if (0 == anthy_xstrcmp( &tmp1, &tmp2 )) {
	    if (cmped_cand_len) {
	      *cmped_cand_len += tmp2.len;
	    }
	    cand_from += tmp2.len;
	    if (cand->len <= cand_from) {
	      return 1;
	    }
	    break;
	  }
	}
	if (s->nr_dic_ents <= j) {
	  return 0;
	}
      } else {
	tmp1.len = cand->len - cand_from;
	tmp1.str = &(cand->str[cand_from]);
	tmp2.len = part->len;
	tmp2.str = &(yomi[part->from]);
	if (tmp1.len <= tmp2.len) {
	  tmp2.len = tmp1.len;
	} else {
	  tmp1.len = tmp2.len;
	}
	if (0 != anthy_xstrcmp( &tmp1, &tmp2 )) {
	  return 0;
	}
	if (cmped_cand_len) {
	  *cmped_cand_len += tmp2.len;
	}
	cand_from += tmp2.len;
	if (cand->len <= cand_from) {
	  return 1;
	}
      }
    }

  } else {
    if (cmped_cand_len) {
      *cmped_cand_len = 0;
    }
    if (mw->mw1) {
      int tmp_len;
      const int ret = mw_is_match_xstr( yomi, cand, cand_from, mw->mw1, &tmp_len );
      if (0 == ret) {
	return 0;
      }
      if (cmped_cand_len) {
	*cmped_cand_len = tmp_len;
      }
      cand_from += tmp_len;
    }
    if (mw->mw2) {
      int tmp_len;
      const int ret = mw_is_match_xstr( yomi, cand, cand_from, mw->mw2, &tmp_len );
      if (0 == ret) {
	return 0;
      }
      if (cmped_cand_len) {
	*cmped_cand_len += tmp_len;
      }
    }
  }
  return 1;
}

/** ʸĹˡǻѲǽ meta_word ʸꥹȤ
 *@param[in,out]	sc			ϥǡ
 *@param[in,out]	parent			ʸꥹ
 *@param		from			Ϥʸ
 *@param		to			λʸ
 *@param		current_depth		ߤʸῼ
 *@param[in,out]	maxdepth		޴ο줿
 *@param[in,out]	maxlen			޴͡줿Ĺʸ
 *
 *	Patched by G-HAL
 *		Sun,16 Nov,2008 - Sat,22 Nov,2008
 *		Mon,19 Jan,2009
 *		Sat,24 Jan,2009, Wed,28 Jan,2009 - Thu,29 Jan,2009
 *		Wed,04 Feb,2009 - Thu,05 Feb,2009
 *		Sun,08 Feb,2009
 */
static void build_path_by_maxlen_n_phrases( struct splitter_context* const sc,
					    struct maxlen_n_phrases_node_t* const parent,
					    ssize_t from, size_t to,
					    size_t current_depth,
					    size_t* const maxdepth,
					    size_t* const maxlen )
{
  struct meta_word*			mw;
  struct maxlen_n_phrases_node_t*	node = NULL;
  struct maxlen_n_phrases_node_t**	node_as;
  int					mw_priority        = 0;
  int					mw_minlen          = 0;
  int					mw_score           = 0;
  size_t				mw_ochaire_phrases = 0;
  int					current_priority;
  int					have_sub_priority;
  int					autoexpand_deps;
  int					mw_autoexpand_deps = 0;
  int					minlen;
  size_t				left_depth = (*maxdepth) - current_depth;
  int					weak_flag;
  size_t				weak_maxdepth = *maxdepth;
  size_t				weak_maxlen   = *maxlen;
  size_t*				maxdepth_p;
  size_t*				maxlen_p;

  /* ѥ޴򻻽 */
  for (mw = sc->word_split_info->cnode[from].mw; mw; mw = mw->next) {
    /* Ŭ */
    if (ok != mw->can_use) {
      continue;
    }
    if (to < (from + mw->len)) {
      continue;
    }
    if ((MW_OCHAIRE == mw->type)
	|| (MW_OCHAIREwithoutDEP == mw->type)
	|| (MW_OCHAIREwithoutINDEP == mw->type)
	|| (MW_OCHAIREwithoutINDEPwithoutDEP == mw->type)
    ) {
      if (!check_is_match_leftmw( sc, parent, mw )) {
	continue;
      }
    }

    /* ޴򻻽 */
    minlen = mw_minlen;
    current_priority = calc_cmpnode_priority( &PRIORITY_OF_METAWORD.MAXLEN, mw, 0, 0, &have_sub_priority, &autoexpand_deps, &minlen );
    if (mw_minlen < minlen) {
      mw_minlen = minlen;
    }
    if (current_priority < mw_priority) {
      continue;
    } else if (mw_priority < current_priority) {
      mw_priority        = current_priority;
      mw_score           = 0;
      mw_ochaire_phrases = 0;
    }
    if (mw_priority == current_priority) {
      if (have_sub_priority) {
	if (mw->score < mw_score) {
	  continue;
	} else if (mw_score < mw->score) {
	  mw_score           = mw->score;
	  mw_ochaire_phrases = 0;
	}
      }
      if ((MW_OCHAIRE == mw->type)
	  || (MW_OCHAIREwithoutDEP == mw->type)
	  || (MW_OCHAIREwithoutINDEP == mw->type)
	  || (MW_OCHAIREwithoutINDEPwithoutDEP == mw->type)
      ) {
	if (mw_ochaire_phrases < mw->ochaire_phrases) {
	  mw_ochaire_phrases = mw->ochaire_phrases;
	}
      }
    }
  }
  /* ա
   * λǤ mw_score  OCHAIREйCAND_HISTORY θäƤʤΤǡ
   * child_top ʣȯǽ롣
   */

  /* ѥڹ¤ι */
  for (mw = sc->word_split_info->cnode[from].mw; mw; mw = mw->next) {
    /* Ŭ */
    if (ok != mw->can_use) {
      continue;
    }
    if (to < (from + mw->len)) {
      continue;
    }
    /* ޴ */
    if ((left_depth <= 0) && ((parent->len + mw->len) < (*maxlen))) {
      continue;
    }
    /* Ŭ */
    if ((MW_OCHAIRE == mw->type)
	|| (MW_OCHAIREwithoutDEP == mw->type)
	|| (MW_OCHAIREwithoutINDEP == mw->type)
	|| (MW_OCHAIREwithoutINDEPwithoutDEP == mw->type)
    ) {
      if (!check_is_match_leftmw( sc, parent, mw )) {
	continue;
      }
    }

    /* ꥹȤɲ */
    current_priority = calc_cmpnode_priority( &PRIORITY_OF_METAWORD.MAXLEN, mw, mw_priority, mw_minlen, &have_sub_priority, &autoexpand_deps, &minlen );
    weak_flag = 1;
    node_as = &(parent->child_weak);
    if (mw_priority <= current_priority) {
      int	set_as_top = 0;
      weak_flag = 0;
      node_as = &(parent->child_normal);
      if (have_sub_priority) {
	if (mw_score <= mw->score) {
	  if ((MW_OCHAIRE == mw->type)
	      || (MW_OCHAIREwithoutDEP == mw->type)
	      || (MW_OCHAIREwithoutINDEP == mw->type)
	      || (MW_OCHAIREwithoutINDEPwithoutDEP == mw->type)
	  ) {
	    if (mw_ochaire_phrases <= mw->ochaire_phrases) {
	      set_as_top = 1;
	    }
	  } else {
	    set_as_top = 1;
	  }
	}
	if (set_as_top) {
	  node_as = &(parent->child_strong);
	  mw_autoexpand_deps = mw_autoexpand_deps || autoexpand_deps;
	} else {
	  weak_flag = 1;
	}
      }
    }
    node = alloc_maxlen_n_phrases_node( parent, node_as, *node_as );
    node->mw    = mw;
    node->from  = from;
    node->to    = from + mw->len;
    node->len   = parent->len + mw->len;
    node->depth = current_depth;
    if (mw->wl) {
      if (anthy_settings.anthy_mode.lattice.maxlen_mode.phrase_with_pre_post_as_2
	  && (0 < mw->wl->part[PART_PREFIX].len) && (0 < mw->wl->part[PART_POSTFIX].len)
      ) {
	node->depth ++;
      }
    }
    {	/* õ */
      maxdepth_p = &weak_maxdepth;
      maxlen_p   = &weak_maxlen;
      if (!weak_flag) {
	maxdepth_p = maxdepth;
	maxlen_p   = maxlen;
      }
      if ((*maxlen_p) < node->len) {
	*maxlen_p = node->len;
	if (!weak_flag && (weak_maxlen < (*maxlen))) {
	  weak_maxlen = *maxlen;
	}
      }
      if (node->depth < (*maxdepth_p)) {
	if (to <= node->to) {
	  *maxdepth_p = node->depth;
	} else {
	  build_path_by_maxlen_n_phrases( sc, node, node->to, to,
					 (node->depth + 1), maxdepth_p, maxlen_p );
	}
	if (!weak_flag) {
	  if (weak_maxlen < (*maxlen)) {
	    weak_maxlen = *maxlen;
	  }
	  if ((*maxdepth) < weak_maxdepth) {
	    weak_maxdepth = *maxdepth;
	  }
	  left_depth = (*maxdepth) - node->depth;
	}
      }
    }
  }

  if (anthy_settings.anthy_mode.lattice.maxlen_mode.autoexpand_deps
      && mw_autoexpand_deps
      && parent->child_strong
  ) {
    /* 򤷤ƤʸڤʤؽפäΤǡ׷˳ʸƥԥåå */
    int	adjust_maxlen = 0;
    struct maxlen_n_phrases_node_t*	child_new = NULL;
    {	/* ׷˳ʸԥåå */
      const struct maxlen_n_phrases_node_t*	node_matter;
      struct maxlen_n_phrases_node_t**	node_store_as   = &child_new;
      struct maxlen_n_phrases_node_t*	node_store_prev = NULL;
      struct maxlen_n_phrases_node_t*	node_next = NULL;
      for (node_matter = parent->child_strong; node_matter; node_matter = node_matter->next) {
	if ((NULL == node_matter->mw->cand_hint.str) || (node_matter->mw->cand_hint.len <= 0)) {
	  continue;	/* It it a bug. ؽͳ mw ϡɬ cand_hint äƤ */
	}
	if (adjust_maxlen < node_matter->len) {
	  adjust_maxlen = node_matter->len;
	}
	for (node = parent->child_weak; node; node = node_next) {
	  node_next = node->next;
	  if (node_matter->len < node->len) {
	    if (mw_is_match_xstr( sc->ce[0].c, &(node_matter->mw->cand_hint), 0, node->mw, NULL )) {
	      /*  */
	      node->mw->ochaire_opposite = mw_priority;
	      if (adjust_maxlen < node->len) {
		adjust_maxlen = node->len;
	      }
	      if (node == parent->child_weak) {
		parent->child_weak = node_next;
	      }
	      if (node->prev) {
		node->prev->next = node->next;
	      }
	      if (node->next) {
		node->next->prev = node->prev;
	      }
	      node->next = NULL;
	      *node_store_as = node;
	      node->prev = node_store_prev;
	      node_store_prev = node;
	      node_store_as = &(node->next);
	    }
	  }
	}
      }
    }
    {	/* ԥååפʪ */
      for (node = parent->child_strong; node->next; node = node->next) {
	;
      }
      node->next = child_new;
      if (child_new) {
	child_new->prev = node;
      }
      child_new = parent->child_strong;
      parent->child_strong = NULL;
      {	/* Ĺʸͥ */
	struct maxlen_n_phrases_node_t**	node_store_as   = &(parent->child_strong);
	struct maxlen_n_phrases_node_t*	node_store_prev = NULL;
	struct maxlen_n_phrases_node_t*	node_next = NULL;
	for (node = child_new; node; node = node_next) {
	  node_next = node->next;
	  if (adjust_maxlen <= node->len) {
	    if (node->mw->cand_hint_freq < (OCHAIRE_SCORE / 2)) {
	      node->mw->cand_hint_freq += (OCHAIRE_SCORE / 2);
	      node->mw->score          += (OCHAIRE_SCORE / 2);
	    }
	    if (node == child_new) {
	      child_new = node_next;
	    }
	    if (node->prev) {
	      node->prev->next = node->next;
	    }
	    if (node->next) {
	      node->next->prev = node->prev;
	    }
	    node->next = NULL;
	    *node_store_as = node;
	    node->prev = node_store_prev;
	    node_store_prev = node;
	    node_store_as = &(node->next);
	  }
	}
      }
      {	/* Ĺʸʳ */
	if (parent->child_normal) {
	  for (node = parent->child_normal; node->next; node = node->next) {
	    ;
	  }
	  node->next = child_new;
	  if (child_new) {
	    child_new->prev = node;
	  }
	} else {
	  parent->child_normal = child_new;
	}
      }
    }
  }

  /* ɲäλ޴ */
  if (((*maxlen) < weak_maxlen)
      || (weak_maxdepth < (*maxdepth))
  ) {
    cut_path_by_maxlen_n_phrases( parent->child_weak, weak_maxdepth, weak_maxlen );
  }

  return;
}

/** build_path_by_maxlen_n_phrases() ǺäꥹȤ顢ǹɾ meta_word õ
 *@param[in]		sc			ϥǡ
 *@param[in,out]	node			ʸꥹ
 *@param[in,out]	mw			ǹɾ meta_word
 *@return					ɾ
 *
 *	Patched by G-HAL
 *		Sun,16 Nov,2008 - Fri,21 Nov,2008
 */
static int
calc_maxscore_by_maxlen_n_phrases( const struct splitter_context* const sc,
				  const struct maxlen_n_phrases_node_t* node,
				  struct meta_word** const mw )
{
  int	max_minlen = INT_MAX;
  int	max_score  = -1;

  if (NULL == node) {
    return 0;
  }

  while (node) {
    struct maxlen_n_phrases_node_t* const	child = node->child_strong ? node->child_strong : (node->child_normal ? node->child_normal : node->child_weak);
    const int	child_score   = calc_maxscore_by_maxlen_n_phrases( sc, child, NULL );
    const int	node_score    = calc_metaword_score( sc, node->mw, (node->parent ? node->parent->mw : NULL) );
    const int	current_score = (child_score + node_score) / (node ? 2 : 1);
    int		hit = 0;
    if (max_score < current_score) {
      hit = 1;
    } else if (max_score == current_score) {
      if (node->len < max_minlen) {
	hit = 1;
      }
    }
    if (hit) {
      if (mw) {
	*mw = node->mw;
      }
      max_minlen = node->len;
      max_score  = current_score;
    }
    node = node->next;
  }

  return max_score;
}

/** ڤäʸФ best_mw ꤹ
 *@param[in,out]	wsic			
 *@param[in]		mw			ϸ mw
 *
 *	Patched by G-HAL
 *		Thu,20 Nov,2008
 *		Sat,24 Jan,2009
 *		Sun,08 Feb,2009
 */
static void
set_bestmw_by_metaword( struct word_split_info_cache* const wsic,
		       struct meta_word* const mw )
{
  if (!wsic || !mw) {
    return;
  }

  switch (mw->type) {
  case MW_DUMMY:
  case MW_SINGLE:
  case MW_COMPOUND_PART:
    break;
  case MW_COMPOUND_LEAF:
    wsic->best_mw[mw->from] = mw;
    mw->can_use = ok;
    break;
  case MW_COMPOUND_HEAD:
  case MW_COMPOUND:
  case MW_NUMBER:
    if (mw->mw1) {
      wsic->best_mw[mw->mw1->from] = mw->mw1;
    }
    set_bestmw_by_metaword( wsic, mw->mw1 );
    set_bestmw_by_metaword( wsic, mw->mw2 );
    break;
  case MW_V_RENYOU_A:
  case MW_V_RENYOU_NOUN:
    break;
  case MW_WRAP:
    set_bestmw_by_metaword( wsic, mw->mw1 );
    break;
  case MW_OCHAIRE:
  case MW_OCHAIREwithoutDEP:
  case MW_OCHAIREwithoutINDEP:
  case MW_OCHAIREwithoutINDEPwithoutDEP:
    set_bestmw_by_metaword( wsic, mw->mw1 );
    break;
  case MW_CANDHISTORY:
    break;
  case MW_END:
  default:
    break;
  }
  return;
}

/** ʸĹˡʸڤ
 *@param[in,out]	sc			ϥǡ
 *@param		from			Ϥʸ
 *@param		to			λʸ
 *
 *@note
 *	âƱʸƱĹä硢
 *	Υ르ꥺɤʤиʸ᤬Ĺ򤵤뤬
 *	Ǥϥƥ༭پǷƤ롣
 *
 *	Patched by G-HAL
 *		Sun,16 Nov,2008 - Fri,21 Nov,2008
 */
static void choose_path_by_maxlen_n_phrases( struct splitter_context* const sc,
					   ssize_t from, size_t to )
{
  if (NULL == sc->word_split_info) {
    return;
  }
  while (from < to) {
    struct maxlen_n_phrases_node_t	top = { NULL,  NULL, NULL, NULL,  NULL, NULL,  NULL,  -1, 0, 0, 0 };
    size_t		maxdepth = anthy_settings.anthy_mode.lattice.maxlen_mode.phrases;
    size_t		maxlen = 0;
    struct meta_word*	mw = NULL;

    build_path_by_maxlen_n_phrases( sc, &top, from, to, (size_t)1, &maxdepth, &maxlen );

    cut_path_by_maxlen_n_phrases( top.child_normal, maxdepth, maxlen );
    cut_path_by_maxlen_n_phrases( top.child_weak  , maxdepth, maxlen );

    if (top.child_strong) {
      struct maxlen_n_phrases_node_t*	node = top.child_strong;
      int				max_score = 0;
      while (node) {
	if (node->mw) {
	  if (max_score < node->mw->score) {
	    mw = node->mw;
	    max_score = mw->score;
	  }
	}
	node = node->next;
      }
    } else {
      calc_maxscore_by_maxlen_n_phrases( sc, top.child_normal, &mw );
      if (NULL == mw) {
	calc_maxscore_by_maxlen_n_phrases( sc, top.child_weak, &mw );
      }
    }
    if (mw) {
      set_bestmw_by_metaword( sc->word_split_info, mw );
      from += mw->len;
      if (to < from) {
	from = to;	/* It is a bug, may be. */
      }
      sc->word_split_info->seg_border[from] = 1;
    } else {
      from = to;
      sc->word_split_info->seg_border[from] = 1;
    }

    free_maxlen_n_phrases_node( &(top.child_strong) );
    free_maxlen_n_phrases_node( &(top.child_normal) );
    free_maxlen_n_phrases_node( &(top.child_weak) );
  }
  return;
}
#endif

/** ʣ mw ֤Ρ
 *@param[in,out]	sc			ϥǡ
 *@param		from			Ϥʸ
 *@param		to			λʸ
 *
 *	Patched by G-HAL
 *		Wed,04 Feb,2009 - Thu,05 Feb,2009, Sun,08 Feb,2009
 */
static void check_dupl_candidate( struct splitter_context* const sc,
				 size_t from, size_t to )
{
  size_t i;
  struct meta_word* mw_i;
  struct meta_word* mw_j;
  for (i = from; i < to; ++i) {
    for (mw_i = sc->word_split_info->cnode[i].mw; mw_i->next; mw_i = mw_i->next) {
      int	i_have_data = 1;
      if (((0 == mw_i->cand_hint_depth_of_dep) && (0 == mw_i->cand_hint_length_of_dep))
	  && ((MW_CANDHISTORY == mw_i->type)
	      || (MW_OCHAIRE == mw_i->type)
	      || (MW_OCHAIREwithoutDEP == mw_i->type)
	      || (MW_OCHAIREwithoutINDEP == mw_i->type)
	      || (MW_OCHAIREwithoutINDEPwithoutDEP == mw_i->type)
	  )
      ) {
	i_have_data = 0;
      }
      for (mw_j = mw_i->next; mw_j; mw_j = mw_j->next) {
	if (mw_i->len == mw_j->len) {
	  int	j_have_data = 1;
	  if (((0 == mw_j->cand_hint_depth_of_dep) && (0 == mw_j->cand_hint_length_of_dep))
	      && ((MW_CANDHISTORY == mw_j->type)
		  || (MW_OCHAIRE == mw_j->type)
		  || (MW_OCHAIREwithoutDEP == mw_j->type)
		  || (MW_OCHAIREwithoutINDEP == mw_j->type)
		  || (MW_OCHAIREwithoutINDEPwithoutDEP == mw_j->type)
	      )
	  ) {
	    j_have_data = 0;
	  }
	  if (!i_have_data && j_have_data && mw_is_match_xstr( sc->ce[0].c, &(mw_i->cand_hint), 0, mw_j, NULL )) {
	    mw_i->cand_hint_depth_of_dep  = mw_j->cand_hint_depth_of_dep;
	    mw_i->cand_hint_length_of_dep = mw_j->cand_hint_length_of_dep;
	    i_have_data = 1;
	  } else if (i_have_data && !j_have_data && mw_is_match_xstr( sc->ce[0].c, &(mw_j->cand_hint), 0, mw_i, NULL )) {
	    mw_j->cand_hint_depth_of_dep  = mw_i->cand_hint_depth_of_dep;
	    mw_j->cand_hint_length_of_dep = mw_i->cand_hint_length_of_dep;
	  }
	}
      }
    }
  }
  return;
}



void
anthy_mark_borders(struct splitter_context *sc, int from, int to)
{
  /* Patched by G-HAL, Wed,04 Feb,2009 */
  if (anthy_settings.anthy_mode.lattice.with_dep_history) {
    check_dupl_candidate( sc, from, to );
  }

  switch (anthy_settings.anthy_mode.lattice.mode) {		/* Patched by G-HAL, Sun,16 Nov,2008 */
  case ANTHY_LATTICE_MODE_VITERBI:
    {
      struct lattice_info* info = alloc_lattice_info(sc, to);
      trans_info_array = anthy_file_dic_get_section("trans_info");
      build_graph(info, from, to);
      choose_path(info, to);
      release_lattice_info(info);
    }
    break;
  case ANTHY_LATTICE_MODE_MAXLEN_BY_N_PHRASES:		/* Patched by G-HAL, Sun,16 Nov,2008 */
    choose_path_by_maxlen_n_phrases( sc, from, to );
    break;
  }
  return;
}
/* vim:ts=8 sw=2 nomodified:
 */
