/**@file
 *			Patches for Anthy, by G-HAL
 *@brief	Ķ
 *@date		Wed,27 Aug,2008 - Fri,29 Aug,2008
 *@date		Fri,17 Oct,2008 - Sat,18 Oct,2008
 *@date		Thu,23 Oct,2008
 *@date		Tue,28 Oct,2008
 *@date		Sat,01 Nov,2008 - Tue,04 Nov,2008
 *@date		Fri,14 Nov,2008 - Sun,16 Nov,2008
 *@date		Sat,22 Nov,2008, Thu,27 Nov,2008
 *@date		Sat,29 Nov,2008
 *@date		Sun,28 Dec,2008, Tue,30 Dec,2008
 *@date		Tue,13 Jan,2009
 *@date		Mon,19 Jan,2009
 *@date		Sat,24 Jan,2009, Sun,25 Jan,2009
 *@date		Mon,26 Jan,2009, Thu,29 Jan,2009
 *@date		Tue,03 Feb,2009, Wed,04 Feb,2009, Fri,06 Feb,2009
 *@date		Sun,08 Feb,2009
 *@author	Copyright(C)2008-2009 G-HAL
 *
 *@note
 *		sample/conf ⻲Ȥ줿
 */

#include "anthy/settings.h"
#include "anthy/segment.h"
#include "anthy/splitter.h"

struct ANTHY_SETTINGS_ anthy_settings = {

	/* ѥ᡼ʤΤǡѹʤ */
	.timestamp = {
		.conffile = 0,
		.initial = 0,
		.currentsession = 0,
	},

	.filename = {
		/* 桼Ķե */
		.user_conffile = "~/.anthy/conf",

		/* ǥ쥯ȥζڤʸ */
		.PathSeparator = "/",

		/* ʲΥե뷲֤ǥ쥯ȥꡣ ${HOME} դ */
		.user_dir = ".anthy",

		/* åե̾˸ߤѴå id̾դ */
		.lock_file = "lock-file_",

		/* Ŀɲü̾˸ߤѴå id̾ȳĥҤդ */
		.private_dic = "private_dict_",
		/* Ŀɲüγĥҡ */
		.private_dic_ext = ".tt",

		/* imported_words ǥ쥯ȥ̾˸ߤѴå id̾ȳĥҤդ */
		.imported_words = "imported_words_",
		/* imported_words ǥ쥯ȥ̾γĥҡ */
		.imported_words_ext = ".d",

		/* ؽ̤εϿ衣˸ߤѴå id̾դ */
		.record1 = "last-record1_",
		.record1_bin_ext = ".bin",
		.record2 = "last-record2_",

		/* ؽ̤ UTF-8 ǵϿγĥҡ */
		.record_ext = ".utf8",
	},

	/* ե°ޥ */
	.file_umask = (S_IRWXG | S_IRWXO),

	/*
	 * ؽǡ last-record2_* ե礭ͤۤƤ硢
	 * եå夷ơlast-record1_* إޡ롣
	 *
	 * ͤ򾮤ȡlast-record2_*  last-record1_ Ѵ٤夬롣
	 * 礭ȡ٤롣
	 * ؽǡ̤ˤϱƶʤ
	 */
	.recordfile2_limit = 131072,
	/*
	 * last-record1_* 礭ͤۤƤ硢
	 * ȥҤξͰʲȤʤͤˡȥ¹Ԥ롣
	 *
	 * ȥͰʲˤʤäƤˤ⤫餺
	 * ե륵ͤۤƤ硢
	 * եΥեåԤ˥ȥ¹Ԥ롣
	 * äơ
	 * ȥͰʲˤʤä last-record1_* Υե륵
	 * Ŭ٤礭ͤꤹ뤳ȡ
	 *
	 * λͤȾͰʲˤʤäΥե륵κϡ
	 * ȥߤ٤夬롣
	 * 礭ϡ٤롣
	 */
	.recordfile1_limit = 1835008,

	/* ƳؽΥҥȾ
	 *
	 * ܤιܤϡ̾ꤹ롣ѹʤȡ
	 * ܤιܤˤơȥξͤꤹ롣
	 * ܤιܤˤơ®ΰ٤ΡԳ̤ꤹ롣¤򤷤Ƥʤѹʤȡ
	 * ܤιܤˤơ®ΰ٤Ργ̤ꤹ롣¤򤷤Ƥʤѹʤȡ
	 *
	 * NONE_SECTION  131072 ϡǤ票ȥꡣ
	 * ѹϡ³Υȥΰ礭ͤ礭뤳ȡ
	 *
	 * ꤷƤ륨ȥϡγؽ̤׻ͤǤ롣
	 * ߤ˹碌ѹ줿
	 */
	.section = {
		[NONE_SECTION]		= { "dummy",			 131072,  0, 0 },
		[EXPANDPAIR]		= { "EXPANDPAIR",		     46,  2, 1 },	/* */
		[UNKNOWN_WORD]		= { "UNKNOWN_WORD",		    463,  4, 1 },
		[SUFFIX_HISTORY]	= { "SUFFIX_HISTORY",	    120,  3, 3 },	/* */
		[INDEPPAIR]			= { "INDEPPAIR",		      0,  1, 1 },
		[OCHAIRE]			= { "OCHAIRE",			   8904,  7, 2 },	/* */
		[CAND_HISTORY]		= { "CAND_HISTORY",		   9352,  3, 3 },	/* */
		[PREDICTION]		= { "PREDICTION",		   9352,  2, 2 },	/* */
		[INDEP_HISTORY]		= { "INDEP_HISTORY",	   4676,  3, 3 },	/* */
		[DEP_HISTORY]		= { "DEP_HISTORY",		    256,  3, 3 },	/* */
		[PREFIX_HISTORY]	= { "PREFIX_HISTORY",	    120,  3, 3 },	/* */
	},
	/*
	 * EXPANDPAIR ΥϡǾ 1ʿѤ 1.41.523 ٤
	 * ޤ 5, 7, 13 餤ޤǤΤǺޤ
	 *
	 * OCHAIRE ϡǾ 5ʿѤ 6.16.2礬 9Ȥꤨͤ 5, 7, 9 λ
	 *
	 * ǤǤ CAND_HISTORY ϡǾ 1ñ̤ 1ʿѤ 2.1礬 8
	 * ѥåǤǤ CAND_HISTORY ϡǾ 3ñ̤ 3ʿѤ 3.13.2礬 36
	 *
	 * PREDICTION ϡǾ 2ñ̤ 2ʿѤ 2.1ͤ
	 * PREDICTION ϡpatch10 ѻߤ
	 *
	 * INDEP_HISTORY ϡpatch13ptn13 ǤοɲäǤ뤿ᡢƼ̤¬
	 * DEP_HISTORY ϡpatch13ptn17 ǤοɲäǤ뤿ᡢƼ̤¬
	 * PREFIX_HISTORY ϡpatch13ptn13 ǤοɲäǤ뤿ᡢƼ̤¬
	 *
	 * ʳΥϡһͤͤǤꡢѲʤ
	 */


	/** ͤ */
	.limit = {
		.ochaire_mindepth = 2,			/* OCHAIREؽκǾʸ */
		.ochaire_maxdepth = 3,			/* OCHAIREؽκʸ */
		.historyrecord_maxdepth = 12,	/* ؽƱɤ߰ۻκϿ */
	},


	/*
	 * ɲõǽ̵ͭ
	 */
	.anthy_mode = {
		.learn = {
			/* ؽ褦ȤƤȿ¸γؽĴ¸γؽ⤫ä硢¸γؽΥŪ˲ */
			.enable_unlearn = 1,

			/* OCHAIREˤơؽ褦ȤʸƤ򤵤˺ʬͤʴ¸γؽä硢 */
			.enable_release = 1,

			/* PREDICTIONؽͭ(1)̵(0)  */
			.enable_prediction = 1,
			/* CAND_HISTORYؽͭ(1)̵(0)  */
			.enable_candhistory = 1,
			/* INDEPPAIRؽͭ(1)̵(0)  */
			.enable_indeppair = 0,
			/* INDEP_HISTORYؽͭ(1)̵(0)  */
			.enable_indephistory = 1,
			/* DEP_HISTORYؽͭ(1)̵(0)  */
			.enable_dephistory = 1,

			/* Ω졦°դʸOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire2 = 1,
			/* °̵ʸOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire2_wo_dep = 1,
			/* Ω̵ʸOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire2_wo_indep = 0,
			/* Ω졦°̵ʸOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire2_wo_indep_wo_dep = 0,

			/* Ω졦°դʸʾOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire3 = 0,
			/* °̵ʸʾOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire3_wo_dep = 1,
			/* Ω̵ʸʾOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire3_wo_indep = 0,
			/* Ω졦°̵ʸʾOCHAIREؽͭ(1)̵(0)  */
			.enable_ochaire3_wo_indep_wo_dep = 0,
		},

		/* ʸڤ */
		.lattice = {
			.mode = ANTHY_LATTICE_MODE_VITERBI,	/* ʸڤΥ⡼ */
			.with_candhistory      = 0,			/* ʸڤ CAND_HISTORY ͥ褹(1)(0) */
			.with_cand_score       = 0,			/* ʸڤκݤʸδܥȤơñΥѤ(1)ñνм̥OCHAIREݤդˤѤ(0) */
			.with_candstruct_score = 0,			/* ʸڤκݤˡ°ˤʸδܥԤ(1)(0) */
			.with_cand_corpus      = 0,			/* ʸڤκݤˡcand_info ѥˤʸδܥԤ(1)(0)false == with_candstruct_score ξ϶Ū̵ */
			.with_dep_history      = 1,			/* ʸڤκݤˡ°ؽˤʸδܥԤ(1)(0) */
			.maxlen_mode = {					/* ʸĹץ⡼ͭ */
				.phrases = 3,						/* lattice_mode ΰ */
				.phrase_with_pre_post_as_2 = 0,		/* ʸĹץ⡼ɻˡƬξʸ򡢣ʸȿ(1)ݤ(0) */
				.autoexpand_deps = 1,				/* °μưĥԤ(1)(0) */
			},
		},

		/* ° */
		.depgraph = {
			.with_xct_symbol = 0,	/* XCT_SYMBOLʸ°ȤϢ뤹(1)(0) */
			.with_xct_part = 0,		/* XCT_PARTʸʤáˤ°ȤϢ뤹(1)(0) */
			/* °ʸ᥹ؤαƶ */
			.score = {
			  #if 0
				.decrease_ratio = 0.01,					/* ʸṽ¤򲼤Ψ°죱 */
				.decrease_ratio_by_length = 0.001,		/* ʸṽ¤򲼤Ψ°죱ʸ */
				.decrease_biasratio = 0.10,				/* ʸṽ¤򲼤Ψʲط̵Ψ */
				.decrease_biasratio_threshold = 2,		/* decrease_biasratio ͭˤ롢°κ */
				.decrease_score = 0,					/* ʸṽ¤򲼤°죱 */
				.decrease_biasscore = 0,				/* ʸṽ¤򲼤ʲط̵Ψ */
				.decrease_biasscore_threshold = 255,	/* decrease_biasscore ͭˤ롢°κ */
			  #elif 0
				.decrease_ratio = 0.00,					/* ʸṽ¤򲼤Ψ°죱 */
				.decrease_ratio_by_length = 0.000,		/* ʸṽ¤򲼤Ψ°죱ʸ */
				.decrease_biasratio = 0.00,				/* ʸṽ¤򲼤Ψʲط̵Ψ */
				.decrease_biasratio_threshold = 255,	/* decrease_biasratio ͭˤ롢°κ */
				.decrease_score = -150,					/* ʸṽ¤˲û°죱 */
				.decrease_biasscore = -1000,			/* ʸṽ¤˲ûʲط̵ */
				.decrease_biasscore_threshold = 2,		/* decrease_biasscore ͭˤ롢°κ */
			  #else
				.decrease_ratio = 0.00,					/* ʸṽ¤򲼤Ψ°죱 */
				.decrease_ratio_by_length = 0.000,		/* ʸṽ¤򲼤Ψ°죱ʸ */
				.decrease_biasratio = 0.50,				/* ʸṽ¤򲼤Ψʲط̵Ψ */
				.decrease_biasratio_threshold = 1,		/* decrease_biasratio ͭˤ롢°κ */
				.decrease_score = -150,					/* ʸṽ¤˲û°죱 */
				.decrease_biasscore = -1000,			/* ʸṽ¤˲ûʲط̵ */
				.decrease_biasscore_threshold = 2,		/* decrease_biasscore ͭˤ롢°κ */
			  #endif
				.increase_biasscore_by_learn = 10,		/* DEP_HISTORYؽ˥ҥåȤβʤ * log(1.0 + ޤǤѲ) */
			},
		},

		/* Ƭ */
		.prefix_suffix = {
			/* ʸ᥹ؤαƶ */
			.score = {
				.increase_ratio_by_learn = 0.50,		/* ʸ᥹夲 */
			},
		},

		/* ʸФüɲ */
		.extra_flag = {
			/* ޤʸؽʤ(1)ؽ(0)
			 * ɤʵ椬ޤޤΤϡ
			 *	src-worddic/exception_word_list.c
			 * 򻲾Ȥ줿
			 */
			.exception_word = {
				.indep_history = 1,		/* INDEPPAIR/INDEP_HISTORY/DEP_HISTORY ˳ؽʤ */
				.ochaire       = 0,		/* OCHAIRE ˳ؽʤ */
				.cand_history  = 0,		/* CAND_HISTORY ˳ؽʤ */
				.prediction    = 0,		/* PREDICTION ˳ؽʤ */
			},
			/* ʸФüե饰ɲ
			 *
			 *	Ѵ¤ӽĴ᤹üե饰
			 *		硧	( * CEF_TUNESCORE_CLOUMN)
			 *		硧	( * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN
			 *		ͤ 0  7 ϰǤʤФʤʤ
			 *		ϰϤۤƤεưꡣ
			 *		ͤϣǤϤʤΤա
			 *
			 *	ư줿ʸؽʤüե饰
			 *		ˤ
			 *			CEF_NONE                        	̤̾ؽ롣
			 *			CEF_DONTLEARN_EXPANDPAIR        	Ǥޤ EXPANDPAIR ؽʤ
			 *			CEF_DONTLEARN_INDEP_HISTORY     	Ǥޤ INDEPPAIR/INDEP_HISTORY ؽʤ
			 *			CEF_DONTLEARN_DEP_HISTORY       	Ǥޤ DEP_HISTORY ؽʤ
			 *			CEF_DONTLEARN_PREDICTION        	Ǥޤ PREDICTION ؽʤ
			 *			CEF_DONTLEARN_CANDHISTORY       	Ǥޤ CAND_HISTORY ؽʤ
			 *			CEF_DONTLEARN_OCHAIRE_IFONLYITS 	ǤǹƤ OCHAIRE ؽʤ
			 *			CEF_DONTLEARN_OCHAIRE_IFHAVEIT  	Ǥޤ OCHAIRE ؽʤ
			 *			CEF_DONTLEARN_ALL               	Ǥޤϰڳؽʤ
			 *		Ȥʣꤹ | ǤĤʤ
			 */
			.guess             = CEF_NONE,		/* ư줿Ǹʸʳʤʸ */
			.hiragana          = CEF_NONE,		/* ư줿Ҥ餬ʤΤߤʸ */
			.katakana          = CEF_NONE,		/* ư줿ʤΤߤʸ */
			.kigou             = CEF_NONE,		/* ư줿εΤߤʸsrc-diclib/xchar.c  half_wide_tab 򻲾ȡ */
			.muhenkan          = CEF_NONE,		/* ư줿̵Ѵʸ */
			.zenhan            = CEF_NONE,		/* ư줿ѤȤȾѤؤʪ */
			.num_ank           = CEF_NONE | (4 * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN,	/* ư줿ȾѤο(ANK) */
			.num_jis           = CEF_NONE | (1 * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN,	/* ư줿Ѥο(JIS X 0208 ) */
			.num_kansuuzi      = CEF_NONE | (2 * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN,	/* ư줿 */
			.num_separated_ank = CEF_NONE | (6 * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN,	/* ư줿ڤ(ANK) */
			.num_separated_jis = CEF_NONE | (5 * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN,	/* ư줿ڤ(JIS X 0208 ) */
			.num_zipcode       = CEF_NONE | (3 * CEF_TUNESCORE_CLOUMN) | CEF_TUNESCORE_SIGN,	/* ͹ֹ漭񤫤Ѵ */
		},
	},
};

/* [ End of File ] */
